// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268404, -0.11664236870396044, 0.0, -0.14682003422210357, 0.07290148043997534, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029515, 0.0972019739199672, 0.2605797108646139, -0.12987926104263034, 0.09768798378956729, -0.06313453403451308 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359521, -0.1683587574253679, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995073, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, -0.16518616813647957, 0.23570226039551626, -0.27216552697590823, -0.12026755886059125, 0.14682003422210418, -0.22453655975512465, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179763, -0.08417937871268426, -0.3499271061118825, 0.0, -0.03388154635894698, -0.07290148043997564, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, 0.06085806194501893, 0.0, 0.21384434262392818, 0.060133779430295506, 0.0395284707521044, 0.11226827987756231, -0.13889597487592942 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268405, 0.11664236870396069, 0.0, 0.14682003422210352, 0.07290148043997556, 0.10101525445522086 },
          { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297928, 0.21384434262392804, -0.26057971086461346, 0.01694077317947359, -0.02478650334959178, 0.03788072042070795 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359528, -0.16835875742536827, -0.34992710611188255, 0.0, -0.06776309271789384, -0.14580296087995104, -0.30304576336566297 },
          { 0.0, 0.0, 0.0, -0.24343224778007344, -0.4040610178208843, -0.6220926330877913, 0.12026755886059075, 0.07905694150420932, 0.07873359887517352, -0.1262690680690267 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179735, -0.08417937871268386, 0.3499271061118822, 0.0, 0.03388154635894676, -0.07290148043997527, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681523, -0.08417937871268394, 0.563771448735811, -0.0601337794302955, 0.0734100171110522, -0.1851697603175378, 0.16414978848973455 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656632, 0.311046316543896, 0.0, -0.09035079029052524, -0.14580296087995098, -0.20203050891044208 },
          { 0.0, 0.0, 0.0, 0.16953317256112296, 0.08417937871268404, 0.116642368703961, 0.16035674514745454, 0.06776309271789356, 0.0320766513935894, -0.07576144084141612 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194846, 0.0, 0.18070158058105035, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014796, -0.07776157913597391, -0.3207134902949092, 0.0903507902905257, -0.06415330278717872, 0.05050762722761055 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.3030457633656641, 0.31104631654389664, 0.0, -0.09035079029052506, 0.14580296087995073, -0.20203050891044186 },
          { 0.0, 0.0, 0.0, 0.21300321680756534, -0.21886638465297967, 0.19440394783993453, 0.1603567451474549, -0.1581138830084198, 0.17787961227354046, -0.12626906806902646 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678166, -0.4761904761904758, -1.6495721976846467, 0.0, -0.31943828249997075, -0.41239304942116023, 0.5714285714285706 },
          { 0.0, 0.0, 0.0, 0.6147592613027617, 0.47619047619047616, -0.5498573992282134, 0.5669467095138396, 0.1597191412499864, -0.45363235436327687, 0.35714285714285765 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.67763092717894, 1.807956714911395, 0.0, 0.0, -0.5868455973269655, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894565, 1.1664236870396079, -0.3367175148507342, 1.041547612244119, 0.6846531968814584, -0.5808377131175195, 0.21870444131992584 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.000000000000001, 0.13041013273932553, -0.8417937871268415, 0.9331389496316868, 0.0, 0.11293848786315612, -0.7290148043997555, -2.020305089104422 },
          { 0.0, 0.0, 0.0, -0.34776035397153177, 0.33671751485073836, 1.3608276348795445, -0.2004459314343186, 0.6211616832473592, 0.5977921396077994, -0.8838834764831881 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423219, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871868, 0.47619047619047516, -0.5498573992282165, 0.0, -0.6388765649999416, 0.41239304942116084, -0.14285714285714196 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357878, 0.0, 0.0, 0.0, 1.1736911946539286, 0.0, 0.0 },
          { 0.0, 3.9999999999999964, 0.0, 0.6776309271789387, -0.5248906591678212, 0.0, -2.0830952244882392, 0.5868455973269651, -0.1010152544552224, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995088, 0.0 },
          { 0.0, 0.0, 3.999999999999998, 0.8259308406823936, 0.8417937871268404, -1.788516320127402, 0.0, -1.1293848786315663, 0.7290148043997549, -0.2525381361380513 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
            { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268404, -0.11664236870396044, 0.0, -0.14682003422210357, 0.07290148043997534, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029515, 0.0972019739199672, 0.2605797108646139, -0.12987926104263034, 0.09768798378956729, -0.06313453403451308 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359521, -0.1683587574253679, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995073, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, -0.16518616813647957, 0.23570226039551626, -0.27216552697590823, -0.12026755886059125, 0.14682003422210418, -0.22453655975512465, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179763, -0.08417937871268426, -0.3499271061118825, 0.0, -0.03388154635894698, -0.07290148043997564, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, 0.06085806194501893, 0.0, 0.21384434262392818, 0.060133779430295506, 0.0395284707521044, 0.11226827987756231, -0.13889597487592942 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268405, 0.11664236870396069, 0.0, 0.14682003422210352, 0.07290148043997556, 0.10101525445522086 },
          { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297928, 0.21384434262392804, -0.26057971086461346, 0.01694077317947359, -0.02478650334959178, 0.03788072042070795 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359528, -0.16835875742536827, -0.34992710611188255, 0.0, -0.06776309271789384, -0.14580296087995104, -0.30304576336566297 },
          { 0.0, 0.0, 0.0, -0.24343224778007344, -0.4040610178208843, -0.6220926330877913, 0.12026755886059075, 0.07905694150420932, 0.07873359887517352, -0.1262690680690267 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179735, -0.08417937871268386, 0.3499271061118822, 0.0, 0.03388154635894676, -0.07290148043997527, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681523, -0.08417937871268394, 0.563771448735811, -0.0601337794302955, 0.0734100171110522, -0.1851697603175378, 0.16414978848973455 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656632, 0.311046316543896, 0.0, -0.09035079029052524, -0.14580296087995098, -0.20203050891044208 },
          { 0.0, 0.0, 0.0, 0.16953317256112296, 0.08417937871268404, 0.116642368703961, 0.16035674514745454, 0.06776309271789356, 0.0320766513935894, -0.07576144084141612 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194846, 0.0, 0.18070158058105035, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014796, -0.07776157913597391, -0.3207134902949092, 0.0903507902905257, -0.06415330278717872, 0.05050762722761055 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.3030457633656641, 0.31104631654389664, 0.0, -0.09035079029052506, 0.14580296087995073, -0.20203050891044186 },
          { 0.0, 0.0, 0.0, 0.21300321680756534, -0.21886638465297967, 0.19440394783993453, 0.1603567451474549, -0.1581138830084198, 0.17787961227354046, -0.12626906806902646 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678166, -0.4761904761904758, -1.6495721976846467, 0.0, -0.31943828249997075, -0.41239304942116023, 0.5714285714285706 },
          { 0.0, 0.0, 0.0, 0.6147592613027617, 0.47619047619047616, -0.5498573992282134, 0.5669467095138396, 0.1597191412499864, -0.45363235436327687, 0.35714285714285765 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.67763092717894, 1.807956714911395, 0.0, 0.0, -0.5868455973269655, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894565, 1.1664236870396079, -0.3367175148507342, 1.041547612244119, 0.6846531968814584, -0.5808377131175195, 0.21870444131992584 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.000000000000001, 0.13041013273932553, -0.8417937871268415, 0.9331389496316868, 0.0, 0.11293848786315612, -0.7290148043997555, -2.020305089104422 },
          { 0.0, 0.0, 0.0, -0.34776035397153177, 0.33671751485073836, 1.3608276348795445, -0.2004459314343186, 0.6211616832473592, 0.5977921396077994, -0.8838834764831881 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423219, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871868, 0.47619047619047516, -0.5498573992282165, 0.0, -0.6388765649999416, 0.41239304942116084, -0.14285714285714196 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357878, 0.0, 0.0, 0.0, 1.1736911946539286, 0.0, 0.0 },
          { 0.0, 3.9999999999999964, 0.0, 0.6776309271789387, -0.5248906591678212, 0.0, -2.0830952244882392, 0.5868455973269651, -0.1010152544552224, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995088, 0.0 },
          { 0.0, 0.0, 3.999999999999998, 0.8259308406823936, 0.8417937871268404, -1.788516320127402, 0.0, -1.1293848786315663, 0.7290148043997549, -0.2525381361380513 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268404, -0.11664236870396044, 0.0, -0.14682003422210357, 0.07290148043997534, -0.10101525445522067 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029515, 0.0972019739199672, 0.2605797108646139, -0.12987926104263034, 0.09768798378956729, -0.06313453403451308 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359521, -0.1683587574253679, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995073, 0.30304576336566275 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647957, 0.23570226039551626, -0.27216552697590823, -0.12026755886059125, 0.14682003422210418, -0.22453655975512465, 0.17677669529663712 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179763, -0.08417937871268426, -0.3499271061118825, 0.0, -0.03388154635894698, -0.07290148043997564, -0.3030457633656631 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501893, 0.0, 0.21384434262392818, 0.060133779430295506, 0.0395284707521044, 0.11226827987756231, -0.13889597487592942 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268405, 0.11664236870396069, 0.0, 0.14682003422210352, 0.07290148043997556, 0.10101525445522086 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297928, 0.21384434262392804, -0.26057971086461346, 0.01694077317947359, -0.02478650334959178, 0.03788072042070795 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359528, -0.16835875742536827, -0.34992710611188255, 0.0, -0.06776309271789384, -0.14580296087995104, -0.30304576336566297 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007344, -0.4040610178208843, -0.6220926330877913, 0.12026755886059075, 0.07905694150420932, 0.07873359887517352, -0.1262690680690267 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179735, -0.08417937871268386, 0.3499271061118822, 0.0, 0.03388154635894676, -0.07290148043997527, 0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681523, -0.08417937871268394, 0.563771448735811, -0.0601337794302955, 0.0734100171110522, -0.1851697603175378, 0.16414978848973455 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656632, 0.311046316543896, 0.0, -0.09035079029052524, -0.14580296087995098, -0.20203050891044208 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112296, 0.08417937871268404, 0.116642368703961, 0.16035674514745454, 0.06776309271789356, 0.0320766513935894, -0.07576144084141612 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194846, 0.0, 0.18070158058105035, 0.0, 0.10101525445522079 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014796, -0.07776157913597391, -0.3207134902949092, 0.0903507902905257, -0.06415330278717872, 0.05050762722761055 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868745, -0.3030457633656641, 0.31104631654389664, 0.0, -0.09035079029052506, 0.14580296087995073, -0.20203050891044186 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756534, -0.21886638465297967, 0.19440394783993453, 0.1603567451474549, -0.1581138830084198, 0.17787961227354046, -0.12626906806902646 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 4.0, 0.0, 0.0, -0.36885555678166, -0.4761904761904758, -1.6495721976846467, 0.0, -0.31943828249997075, -0.41239304942116023, 0.5714285714285706 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027617, 0.47619047619047616, -0.5498573992282134, 0.5669467095138396, 0.1597191412499864, -0.45363235436327687, 0.35714285714285765 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.67763092717894, 1.807956714911395, 0.0, 0.0, -0.5868455973269655, -1.2626906806902614, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894565, 1.1664236870396079, -0.3367175148507342, 1.041547612244119, 0.6846531968814584, -0.5808377131175195, 0.21870444131992584 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 4.000000000000001, 0.13041013273932553, -0.8417937871268415, 0.9331389496316868, 0.0, 0.11293848786315612, -0.7290148043997555, -2.020305089104422 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153177, 0.33671751485073836, 1.3608276348795445, -0.2004459314343186, 0.6211616832473592, 0.5977921396077994, -0.8838834764831881 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423219, 0.0 };
            static const double coefficients1[10] = { 4.0, 0.0, 0.0, -1.5983740793871868, 0.47619047619047516, -0.5498573992282165, 0.0, -0.6388765649999416, 0.41239304942116084, -0.14285714285714196 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.355261854357878, 0.0, 0.0, 0.0, 1.1736911946539286, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.9999999999999964, 0.0, 0.6776309271789387, -0.5248906591678212, 0.0, -2.0830952244882392, 0.5868455973269651, -0.1010152544552224, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995088, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999998, 0.8259308406823936, 0.8417937871268404, -1.788516320127402, 0.0, -1.1293848786315663, 0.7290148043997549, -0.2525381361380513 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865471, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.9933259094191627, 13.662601021279466, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413615, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137762, 0.0, 7.838367176906178, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.7434164902525735, -0.9128709291752787, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999185, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584874, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064567, 5.184592558726248, -1.4966629547095622, 6.831300510639719, -1.0583005244258294, 0.30550504633038816, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998373, 2.1908902300206896, 2.5298221281346867, 8.082903768654775, 6.260990336999421, -1.8073922282301267, 0.0, 0.0, 0.0, 0.0 },
                  { 1.732050807568879, -5.091168824543127, 3.9191835884530994, 0.0, 9.699484522385703, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000022, 0.0, -2.8284271247462702, 0.0, 0.0, 12.124355652982132, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.9999999999999987) + dof_values[4] * (K[2] * -2.999999999999997) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.9999999999999982) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000003) + dof_values[1] * (K[2] * -3.000000000000006) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0 + K[2] * -3.000000000000003) + dof_values[8] * (K[0] * 3.000000000000001 + K[2] * 3.000000000000006);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999964) + dof_values[2] * (K[0] * -2.999999999999999) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.999999999999999 + K[2] * -3.0000000000000027) + dof_values[5] * (K[0] * 2.9999999999999973 + K[2] * 3.0000000000000027);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.9999999999999987) + dof_values[4] * (K[2 + 1] * -2.999999999999997) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.9999999999999982) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000003) + dof_values[1] * (K[2 + 1] * -3.000000000000006) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0 + K[2 + 1] * -3.000000000000003) + dof_values[8] * (K[1] * 3.000000000000001 + K[2 + 1] * 3.000000000000006);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999964) + dof_values[2] * (K[1] * -2.999999999999999) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.999999999999999 + K[2 + 1] * -3.0000000000000027) + dof_values[5] * (K[1] * 2.9999999999999973 + K[2 + 1] * 3.0000000000000027);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333346 * sp[33] + 0.358333333333346 * sp[34] + -0.6083333333333379 * sp[28] + -0.608333333333327 * sp[31] + 0.358333333333346 * sp[34] + 0.8583333333333476 * sp[35] + -1.875000000000024 * sp[29] + -0.6083333333333391 * sp[32] + -0.6083333333333379 * sp[28] + -1.875000000000024 * sp[29] + 6.191666666666721 * sp[26] + 1.691666666666665 * sp[27] + -0.608333333333327 * sp[31] + -0.6083333333333391 * sp[32] + 1.691666666666665 * sp[27] + 0.6333333333333263 * sp[30];
    A[1] = -2.016666666666665 * sp[33] + 1.116666666666656 * sp[34] + -0.6166666666666691 * sp[28] + -0.6166666666666811 * sp[31] + 0.2833333333333283 * sp[34] + -0.8000000000000032 * sp[35] + sp[29] + -0.6166666666666821 * sp[32] + 0.2166666666666689 * sp[28] + 1.666666666666686 * sp[29] + -3.466666666666702 * sp[26] + 2.783333333333362 * sp[27] + 0.216666666666658 * sp[31] + 0.2166666666666783 * sp[32] + -0.7166666666666706 * sp[27] + 0.8166666666666642 * sp[30];
    A[2] = -0.03333333333332766 * sp[33] + -0.8916666666666516 * sp[34] + -0.1916666666666726 * sp[28] + -0.1916666666666675 * sp[31] + 0.4416666666666711 * sp[34] + 1.275000000000002 * sp[35] + -0.7916666666666758 * sp[29] + -0.1916666666666628 * sp[32] + -0.1916666666666678 * sp[28] + -0.791666666666671 * sp[29] + 1.275000000000012 * sp[26] + -0.8916666666666787 * sp[27] + -0.1916666666666697 * sp[31] + -0.1916666666666778 * sp[32] + 0.4416666666666696 * sp[27] + -0.03333333333333216 * sp[30];
    A[3] = -1.591666666666686 * sp[33] + -0.6500000000000165 * sp[34] + -2.283333333333351 * sp[28] + -0.6500000000000206 * sp[31] + -0.9416666666666805 * sp[34] + -1.295833333333349 * sp[35] + -0.1125000000000015 * sp[29] + -0.4666666666666756 * sp[32] + 0.6916666666666718 * sp[28] + 1.52083333333335 * sp[29] + -1.09583333333334 * sp[26] + -0.2666666666666524 * sp[27] + 0.6916666666666675 * sp[31] + 0.6916666666666721 * sp[32] + 0.6916666666666641 * sp[27] + 0.5083333333333411 * sp[30];
    A[4] = -0.06666666666665499 * sp[33] + -0.5333333333333139 * sp[34] + -0.09999999999999265 * sp[28] + -0.533333333333319 * sp[31] + 0.8833333333333411 * sp[34] + 1.675000000000006 * sp[35] + 0.1416666666666677 * sp[29] + 0.9333333333333247 * sp[32] + -0.3833333333333358 * sp[28] + -0.9583333333333371 * sp[29] + 0.4416666666666659 * sp[26] + -0.1333333333333351 * sp[27] + -0.3833333333333392 * sp[31] + -0.3833333333333445 * sp[32] + -0.3833333333333362 * sp[27] + -0.6000000000000077 * sp[30];
    A[5] = -1.00833333333333 * sp[33] + 1.183333333333324 * sp[34] + -2.116666666666668 * sp[28] + 1.183333333333325 * sp[31] + 0.1416666666666647 * sp[34] + -0.8374999999999994 * sp[35] + 0.5124999999999998 * sp[29] + -0.4666666666666625 * sp[32] + 0.1083333333333332 * sp[28] + 1.145833333333343 * sp[29] + -0.6375000000000104 * sp[26] + 0.4000000000000135 * sp[27] + 0.108333333333328 * sp[31] + 0.1083333333333438 * sp[32] + 0.1083333333333224 * sp[27] + 0.09166666666667904 * sp[30];
    A[6] = -1.091666666666676 * sp[33] + -1.108333333333343 * sp[34] + -1.108333333333344 * sp[28] + -1.10833333333334 * sp[31] + -0.7333333333333453 * sp[34] + -0.3624999999999972 * sp[35] + -1.479166666666688 * sp[29] + -1.108333333333343 * sp[32] + 2.133333333333354 * sp[28] + 1.154166666666663 * sp[29] + 3.170833333333359 * sp[26] + 2.19166666666667 * sp[27] + 1.149999999999997 * sp[31] + 1.116666666666658 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333327 * sp[30];
    A[7] = 2.600000000000015 * sp[33] + 1.216666666666667 * sp[34] + 1.216666666666674 * sp[28] + 1.216666666666664 * sp[31] + 1.466666666666684 * sp[34] + 0.3083333333333415 * sp[35] + 2.375000000000031 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333373 * sp[28] + -1.058333333333334 * sp[29] + -7.258333333333392 * sp[26] + -3.383333333333335 * sp[27] + -2.133333333333324 * sp[31] + -0.899999999999993 * sp[32] + -2.133333333333329 * sp[27] + -1.266666666666654 * sp[30];
    A[8] = -1.508333333333343 * sp[33] + 0.3083333333333489 * sp[34] + 0.3083333333333351 * sp[28] + 0.3083333333333472 * sp[31] + -0.7333333333333383 * sp[34] + 0.7625000000000086 * sp[35] + -1.187500000000012 * sp[29] + 0.3083333333333431 * sp[32] + 2.80000000000002 * sp[28] + -2.887500000000019 * sp[29] + 4.295833333333376 * sp[26] + -1.391666666666689 * sp[27] + 0.9833333333333276 * sp[31] + -0.7166666666666621 * sp[32] + 0.9833333333333349 * sp[27] + -0.4083333333333348 * sp[30];
    A[9] = 1.64991582276867 * sp[33] + 0.4714045207910607 * sp[34] + -5.185449728701379 * sp[28] + -5.185449728701382 * sp[31] + 3.064129385141741 * sp[34] + 1.767766952966356 * sp[35] + -3.889087296526077 * sp[29] + -5.185449728701427 * sp[32] + -1.649915822768626 * sp[28] + 5.06759859850362 * sp[29] + 10.72445284799603 * sp[26] + 17.44196726926825 * sp[27] + -1.649915822768629 * sp[31] + -0.2357022603955397 * sp[32] + 4.006938426723743 * sp[27] + 5.892556509887854 * sp[30];
    A[10] = 10.96965511460294 * sp[33] + 0.7216878364869928 * sp[34] + -10.53664241271074 * sp[28] + -10.53664241271075 * sp[31] + 0.1443375672973164 * sp[34] + -1.732050807568889 * sp[35] + -8.660254037844531 * sp[29] + -10.5366424127108 * sp[32] + 0.7216878364870876 * sp[28] + 11.54700538379252 * sp[29] + 18.47520861406814 * sp[26] + 29.30052616137364 * sp[27] + 0.721687836487058 * sp[31] + 5.051814855409178 * sp[32] + 7.64989106676251 * sp[27] + 10.96965511460282 * sp[30];
    A[11] = -6.833333333333318 * sp[33] + 1.583333333333388 * sp[34] + 0.08333333333330284 * sp[28] + 0.0833333333333135 * sp[31] + 2.41666666666667 * sp[34] + 3.749999999999962 * sp[35] + -1.250000000000008 * sp[29] + 0.08333333333337523 * sp[32] + 0.08333333333333279 * sp[28] + -4.916666666666656 * sp[29] + -5.916666666666716 * sp[26] + -10.91666666666675 * sp[27] + 0.08333333333329296 * sp[31] + 0.5833333333333346 * sp[32] + -0.9166666666666398 * sp[27] + -1.833333333333307 * sp[30];
    A[12] = 5.892556509887862 * sp[33] + -1.649915822768637 * sp[34] + 16.7348604880817 * sp[28] + 4.006938426723815 * sp[31] + -3.299831645537233 * sp[34] + -2.474873734152932 * sp[35] + 3.181980515339542 * sp[29] + 4.006938426723855 * sp[32] + 0.4714045207910328 * sp[28] + -2.003469213361922 * sp[29] + -7.66032346285431 * sp[26] + -10.1351971970073 * sp[27] + 0.4714045207910744 * sp[31] + 0.4714045207910322 * sp[32] + -5.185449728701299 * sp[27] + -4.006938426723782 * sp[30];
    A[13] = -16.8874953737967 * sp[33] + -7.361215932167809 * sp[34] + -7.361215932167783 * sp[28] + 3.897114317029937 * sp[31] + -5.196152422706716 * sp[34] + -6.278684177437307 * sp[35] + 4.979646071760508 * sp[29] + 3.897114317029912 * sp[32] + 5.19615242270666 * sp[28] + 11.90784930203618 * sp[29] + -21.86714144555723 * sp[26] + -15.15544456622758 * sp[27] + 5.196152422706604 * sp[31] + 5.196152422706644 * sp[32] + -1.732050807568879 * sp[27] + -3.897114317029875 * sp[30];
    A[14] = 10.41666666666659 * sp[33] + -2.916666666666717 * sp[34] + 10.08333333333335 * sp[28] + -1.416666666666657 * sp[31] + -5.833333333333353 * sp[34] + -4.375000000000025 * sp[35] + -2.874999999999989 * sp[29] + -1.416666666666779 * sp[32] + 0.8333333333333343 * sp[28] + -3.541666666666728 * sp[29] + 7.95833333333342 * sp[26] + 3.583333333333328 * sp[27] + 0.8333333333334098 * sp[31] + 0.8333333333333366 * sp[32] + 1.833333333333372 * sp[27] + 2.916666666666633 * sp[30];
    A[15] = -2.016666666666665 * sp[33] + 0.2833333333333283 * sp[34] + 0.2166666666666689 * sp[28] + 0.216666666666658 * sp[31] + 1.116666666666656 * sp[34] + -0.8000000000000032 * sp[35] + 1.666666666666686 * sp[29] + 0.2166666666666783 * sp[32] + -0.6166666666666691 * sp[28] + sp[29] + -3.466666666666702 * sp[26] + -0.7166666666666706 * sp[27] + -0.6166666666666811 * sp[31] + -0.6166666666666821 * sp[32] + 2.783333333333362 * sp[27] + 0.8166666666666642 * sp[30];
    A[16] = 2.533333333333328 * sp[33] + -1.733333333333329 * sp[34] + 0.7333333333333351 * sp[28] + 0.7333333333333512 * sp[31] + -1.733333333333329 * sp[34] + 2.766666666666656 * sp[35] + -2.166666666666673 * sp[29] + 0.7333333333333423 * sp[32] + 0.7333333333333351 * sp[28] + -2.166666666666673 * sp[29] + 2.766666666666694 * sp[26] + -1.733333333333347 * sp[27] + 0.7333333333333512 * sp[31] + 0.7333333333333423 * sp[32] + -1.733333333333347 * sp[27] + 2.533333333333346 * sp[30];
    A[17] = 0.816666666666668 * sp[33] + 2.783333333333328 * sp[34] + -0.6166666666666685 * sp[28] + -0.6166666666666731 * sp[31] + -0.716666666666672 * sp[34] + -3.466666666666666 * sp[35] + sp[29] + -0.6166666666666732 * sp[32] + 0.2166666666666679 * sp[28] + 1.666666666666668 * sp[29] + -0.8000000000000081 * sp[26] + 1.116666666666674 * sp[27] + 0.2166666666666734 * sp[31] + 0.2166666666666733 * sp[32] + 0.2833333333333362 * sp[27] + -2.016666666666676 * sp[30];
    A[18] = -0.06666666666666607 * sp[33] + -0.949999999999996 * sp[34] + 0.31666666666667 * sp[28] + -0.9499999999999899 * sp[31] + 0.4666666666666789 * sp[34] + 1.258333333333345 * sp[35] + -0.1083333333333369 * sp[29] + 0.6833333333333376 * sp[32] + 0.03333333333333333 * sp[28] + -0.708333333333339 * sp[29] + 0.8583333333333374 * sp[26] + 0.1166666666666596 * sp[27] + 0.03333333333333335 * sp[31] + 0.03333333333333974 * sp[32] + 0.03333333333331109 * sp[27] + -0.1833333333333422 * sp[30];
    A[19] = 1.633333333333333 * sp[33] + 3.066666666666661 * sp[34] + 1.199999999999994 * sp[28] + 3.066666666666659 * sp[31] + -1.433333333333342 * sp[34] + -3.683333333333337 * sp[35] + -0.2833333333333317 * sp[29] + -2.533333333333316 * sp[32] + 0.4333333333333356 * sp[28] + 1.583333333333335 * sp[29] + -0.2166666666666637 * sp[26] + 0.9333333333333405 * sp[27] + 0.4333333333333453 * sp[31] + 0.4333333333333413 * sp[32] + 0.4333333333333553 * sp[27] + 1.200000000000033 * sp[30];
    A[20] = 1.266666666666662 * sp[33] + -2.116666666666662 * sp[34] + 2.483333333333333 * sp[28] + -2.116666666666666 * sp[31] + -0.8666666666666628 * sp[34] + 3.008333333333324 * sp[35] + -2.025000000000003 * sp[29] + 1.849999999999981 * sp[32] + 0.3666666666666669 * sp[28] + -1.958333333333337 * sp[29] + 1.275000000000011 * sp[26] + -1.050000000000007 * sp[27] + 0.3666666666666746 * sp[31] + 0.3666666666666691 * sp[32] + 0.3666666666666751 * sp[27] + -1.016666666666671 * sp[30];
    A[21] = 0.1833333333333412 * sp[33] + -0.03333333333332658 * sp[34] + -0.0333333333333333 * sp[28] + -0.03333333333333377 * sp[31] + -0.1166666666666597 * sp[34] + -0.8583333333333436 * sp[35] + 0.7083333333333544 * sp[29] + -0.03333333333332655 * sp[32] + -0.6833333333333478 * sp[28] + 0.108333333333329 * sp[29] + -1.258333333333349 * sp[26] + -0.4666666666666694 * sp[27] + 0.9499999999999993 * sp[31] + -0.3166666666666963 * sp[32] + 0.9500000000000139 * sp[27] + 0.06666666666666185 * sp[30];
    A[22] = -1.200000000000006 * sp[33] + -0.4333333333333288 * sp[34] + -0.4333333333333354 * sp[28] + -0.4333333333333275 * sp[31] + -0.9333333333333425 * sp[34] + 0.2166666666666536 * sp[35] + -1.583333333333361 * sp[29] + -0.4333333333333506 * sp[32] + 2.533333333333362 * sp[28] + 0.28333333333334 * sp[29] + 3.683333333333372 * sp[26] + 1.43333333333334 * sp[27] + -3.066666666666676 * sp[31] + -1.199999999999983 * sp[32] + -3.066666666666699 * sp[27] + -1.63333333333333 * sp[30];
    A[23] = 1.016666666666671 * sp[33] + -0.3666666666666903 * sp[34] + -0.3666666666666667 * sp[28] + -0.3666666666666819 * sp[31] + 1.049999999999997 * sp[34] + -1.275000000000004 * sp[35] + 1.958333333333343 * sp[29] + -0.3666666666666688 * sp[32] + -1.850000000000012 * sp[28] + 2.025000000000008 * sp[29] + -3.008333333333365 * sp[26] + 0.8666666666666748 * sp[27] + 2.116666666666678 * sp[31] + -2.483333333333346 * sp[32] + 2.116666666666685 * sp[27] + -1.266666666666676 * sp[30];
    A[24] = 3.771236166328243 * sp[33] + 6.128258770283439 * sp[34] + 3.299831645537233 * sp[28] + 3.299831645537254 * sp[31] + -3.771236166328278 * sp[34] + 1.178511301977611 * sp[35] + -1.649915822768556 * sp[29] + 3.299831645537296 * sp[32] + 0.9428090415820636 * sp[28] + -5.421151989096877 * sp[29] + -2.5927248643507 * sp[26] + -8.956685895029654 * sp[27] + 0.9428090415820866 * sp[31] + 12.25651754056689 * sp[32] + 3.771236166328306 * sp[27] + 11.78511301977581 * sp[30];
    A[25] = -8.94892917243917 * sp[33] + -1.443375672973968 * sp[34] + 3.752776749732578 * sp[28] + 3.752776749732621 * sp[31] + -3.175426480542766 * sp[34] + 2.020725942163698 * sp[35] + -1.443375672973925 * sp[29] + 3.752776749732673 * sp[32] + 1.443375672974 * sp[28] + -7.216878364870358 * sp[29] + -3.752776749732627 * sp[26] + -12.41303078757703 * sp[27] + 1.443375672973959 * sp[31] + 10.10362971081832 * sp[32] + 4.90747728811191 * sp[27] + 14.14508159514585 * sp[30];
    A[26] = 11.16666666666667 * sp[33] + 1.833333333333293 * sp[34] + -5.166666666666692 * sp[28] + -5.1666666666667 * sp[31] + -8.166666666666679 * sp[34] + -16.66666666666664 * sp[35] + 3.333333333333362 * sp[29] + -5.166666666666742 * sp[32] + 3.166666666666681 * sp[28] + 10.66666666666665 * sp[29] + 2.666666666666698 * sp[26] + 10.16666666666673 * sp[27] + 3.166666666666751 * sp[31] + -7.833333333333412 * sp[32] + -4.833333333333386 * sp[27] + -17.16666666666674 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328264 * sp[34] + -12.25651754056682 * sp[28] + -0.942809041582064 * sp[31] + 8.956685895029619 * sp[34] + 2.592724864350733 * sp[35] + 5.42115198909681 * sp[29] + -0.9428090415821044 * sp[32] + -3.299831645537232 * sp[28] + 1.649915822768618 * sp[29] + -1.178511301977578 * sp[26] + 3.771236166328301 * sp[27] + -3.299831645537309 * sp[31] + -3.299831645537271 * sp[32] + -6.128258770283493 * sp[27] + -3.771236166328308 * sp[30];
    A[28] = 7.794228634060001 * sp[33] + 1.732050807568896 * sp[34] + 1.732050807568883 * sp[28] + -3.464101615137746 * sp[31] + -2.598076211353285 * sp[34] + -0.4330127018921326 * sp[35] + -5.629165124598778 * sp[29] + -3.464101615137689 * sp[32] + 2.598076211353352 * sp[28] + -2.16506350946115 * sp[29] + 13.42339375865891 * sp[26] + 8.660254037844371 * sp[27] + 2.598076211353382 * sp[31] + 2.598076211353414 * sp[32] + -0.866025403784632 * sp[27] + -5.196152422706595 * sp[30];
    A[29] = -20.83333333333331 * sp[33] + -6.666666666666674 * sp[34] + -12.66666666666665 * sp[28] + 0.3333333333333592 * sp[31] + 15.83333333333336 * sp[34] + 4.583333333333421 * sp[35] + 11.58333333333332 * sp[29] + 0.3333333333335893 * sp[32] + -5.833333333333348 * sp[28] + 2.916666666666683 * sp[29] + -10.08333333333342 * sp[26] + -1.33333333333337 * sp[27] + -5.833333333333488 * sp[31] + -5.833333333333419 * sp[32] + 2.166666666666585 * sp[27] + 13.33333333333324 * sp[30];
    A[30] = -0.03333333333332766 * sp[33] + 0.4416666666666711 * sp[34] + -0.1916666666666678 * sp[28] + -0.1916666666666697 * sp[31] + -0.8916666666666516 * sp[34] + 1.275000000000002 * sp[35] + -0.791666666666671 * sp[29] + -0.1916666666666778 * sp[32] + -0.1916666666666726 * sp[28] + -0.7916666666666758 * sp[29] + 1.275000000000012 * sp[26] + 0.4416666666666696 * sp[27] + -0.1916666666666675 * sp[31] + -0.1916666666666628 * sp[32] + -0.8916666666666787 * sp[27] + -0.03333333333333216 * sp[30];
    A[31] = 0.816666666666668 * sp[33] + -0.716666666666672 * sp[34] + 0.2166666666666679 * sp[28] + 0.2166666666666734 * sp[31] + 2.783333333333328 * sp[34] + -3.466666666666666 * sp[35] + 1.666666666666668 * sp[29] + 0.2166666666666733 * sp[32] + -0.6166666666666685 * sp[28] + sp[29] + -0.8000000000000081 * sp[26] + 0.2833333333333362 * sp[27] + -0.6166666666666731 * sp[31] + -0.6166666666666732 * sp[32] + 1.116666666666674 * sp[27] + -2.016666666666676 * sp[30];
    A[32] = 0.6333333333333395 * sp[33] + 1.691666666666678 * sp[34] + -0.6083333333333398 * sp[28] + -0.6083333333333404 * sp[31] + 1.691666666666678 * sp[34] + 6.191666666666677 * sp[35] + -1.875000000000012 * sp[29] + -0.6083333333333357 * sp[32] + -0.6083333333333398 * sp[28] + -1.875000000000012 * sp[29] + 0.8583333333333409 * sp[26] + 0.3583333333333356 * sp[27] + -0.6083333333333404 * sp[31] + -0.6083333333333357 * sp[32] + 0.3583333333333356 * sp[27] + 2.63333333333335 * sp[30];
    A[33] = -1.008333333333345 * sp[33] + -1.150000000000009 * sp[34] + -1.116666666666674 * sp[28] + -1.150000000000007 * sp[31] + -2.191666666666688 * sp[34] + -3.170833333333346 * sp[35] + -1.154166666666679 * sp[29] + -2.133333333333341 * sp[32] + 1.108333333333346 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000129 * sp[26] + 0.733333333333346 * sp[27] + 1.108333333333343 * sp[31] + 1.108333333333336 * sp[32] + 1.108333333333356 * sp[27] + 1.091666666666678 * sp[30];
    A[34] = 1.266666666666677 * sp[33] + 2.133333333333347 * sp[34] + 0.9000000000000019 * sp[28] + 2.133333333333342 * sp[31] + 3.38333333333335 * sp[34] + 7.258333333333349 * sp[35] + 1.058333333333334 * sp[29] + 4.933333333333333 * sp[32] + -1.216666666666678 * sp[28] + -2.375000000000013 * sp[29] + -0.3083333333333408 * sp[26] + -1.466666666666681 * sp[27] + -1.216666666666679 * sp[31] + -1.216666666666672 * sp[32] + -1.216666666666682 * sp[27] + -2.600000000000027 * sp[30];
    A[35] = 0.4083333333333339 * sp[33] + -0.9833333333333389 * sp[34] + 0.7166666666666702 * sp[28] + -0.9833333333333422 * sp[31] + 1.391666666666663 * sp[34] + -4.295833333333334 * sp[35] + 2.887500000000001 * sp[29] + -2.800000000000002 * sp[32] + -0.3083333333333346 * sp[28] + 1.187500000000008 * sp[29] + -0.7625000000000044 * sp[26] + 0.7333333333333472 * sp[27] + -0.3083333333333366 * sp[31] + -0.3083333333333389 * sp[32] + -0.3083333333333356 * sp[27] + 1.508333333333342 * sp[30];
    A[36] = -0.5083333333333329 * sp[33] + -0.6916666666666673 * sp[34] + -0.6916666666666738 * sp[28] + -0.6916666666666715 * sp[31] + 0.2666666666666687 * sp[34] + 1.095833333333339 * sp[35] + -1.520833333333349 * sp[29] + -0.6916666666666719 * sp[32] + 0.4666666666666748 * sp[28] + 0.1125000000000073 * sp[29] + 1.295833333333344 * sp[26] + 0.9416666666666725 * sp[27] + 0.650000000000005 * sp[31] + 2.283333333333365 * sp[32] + 0.6499999999999986 * sp[27] + 1.591666666666679 * sp[30];
    A[37] = 0.6000000000000019 * sp[33] + 0.3833333333333367 * sp[34] + 0.383333333333336 * sp[28] + 0.383333333333336 * sp[31] + 0.1333333333333392 * sp[34] + -0.4416666666666523 * sp[35] + 0.9583333333333421 * sp[29] + 0.3833333333333452 * sp[32] + -0.9333333333333506 * sp[28] + -0.141666666666675 * sp[29] + -1.675000000000014 * sp[26] + -0.8833333333333382 * sp[27] + 0.5333333333333297 * sp[31] + 0.09999999999998632 * sp[32] + 0.5333333333333468 * sp[27] + 0.06666666666666388 * sp[30];
    A[38] = -0.09166666666666645 * sp[33] + -0.1083333333333435 * sp[34] + -0.1083333333333331 * sp[28] + -0.1083333333333378 * sp[31] + -0.399999999999999 * sp[34] + 0.6374999999999835 * sp[35] + -1.145833333333334 * sp[29] + -0.108333333333341 * sp[32] + 0.4666666666666736 * sp[28] + -0.5124999999999966 * sp[29] + 0.8375000000000081 * sp[26] + -0.1416666666666689 * sp[27] + -1.183333333333336 * sp[31] + 2.116666666666683 * sp[32] + -1.183333333333344 * sp[27] + 1.008333333333338 * sp[30];
    A[39] = 4.006938426723806 * sp[33] + 5.185449728701402 * sp[34] + -0.4714045207910367 * sp[28] + -0.4714045207910216 * sp[31] + 10.13519719700723 * sp[34] + 7.660323462854311 * sp[35] + 2.003469213361863 * sp[29] + -0.4714045207910476 * sp[32] + -4.00693842672381 * sp[28] + -3.181980515339506 * sp[29] + 2.474873734152935 * sp[26] + 3.299831645537245 * sp[27] + -4.006938426723808 * sp[31] + -16.73486048808173 * sp[32] + 1.649915822768597 * sp[27] + -5.892556509887908 * sp[30];
    A[40] = -0.5773502691895879 * sp[33] + -0.7216878364869815 * sp[34] + -3.319764047840382 * sp[28] + -3.319764047840352 * sp[31] + 4.474464586219606 * sp[34] + 4.04145188432746 * sp[35] + -2.886751345948217 * sp[29] + -3.319764047840376 * sp[32] + -0.7216878364870476 * sp[28] + 6.928203230275564 * sp[26] + 7.649891066762593 * sp[27] + -0.7216878364870314 * sp[31] + -5.051814855409166 * sp[32] + 6.206515393788468 * sp[27] + -0.5773502691895933 * sp[30];
    A[41] = 4.833333333333365 * sp[33] + 2.416666666666668 * sp[34] + -4.083333333333382 * sp[28] + -4.083333333333384 * sp[31] + 14.91666666666671 * sp[34] + 22.91666666666667 * sp[35] + -12.08333333333342 * sp[29] + -4.083333333333334 * sp[32] + -4.083333333333369 * sp[28] + -5.749999999999993 * sp[29] + 3.25000000000003 * sp[26] + 1.583333333333345 * sp[27] + -4.083333333333384 * sp[31] + 11.41666666666677 * sp[32] + 4.916666666666716 * sp[27] + 19.83333333333346 * sp[30];
    A[42] = -5.892556509887935 * sp[33] + -4.006938426723802 * sp[34] + 0.2357022603955443 * sp[28] + 1.649915822768639 * sp[31] + -17.44196726926823 * sp[34] + -10.72445284799605 * sp[35] + -5.067598598503512 * sp[29] + 1.649915822768651 * sp[32] + 5.185449728701391 * sp[28] + 3.889087296526031 * sp[29] + -1.76776695296641 * sp[26] + -3.06412938514176 * sp[27] + 5.185449728701407 * sp[31] + 5.185449728701387 * sp[32] + -0.4714045207910393 * sp[27] + -1.649915822768623 * sp[30];
    A[43] = -3.897114317030008 * sp[33] + -3.031088913245569 * sp[34] + -3.031088913245561 * sp[28] + -0.4330127018922425 * sp[31] + -5.196152422706669 * sp[34] + -4.113620667976133 * sp[35] + -1.515544456622875 * sp[29] + -0.4330127018922674 * sp[32] + 5.196152422706673 * sp[28] + 5.412658773652797 * sp[29] + -2.381569860407188 * sp[26] + -2.165063509461068 * sp[27] + 5.196152422706654 * sp[31] + 5.196152422706625 * sp[32] + -1.732050807568767 * sp[27] + 0.4330127018922019 * sp[30];
    A[44] = -10.41666666666674 * sp[33] + -7.083333333333384 * sp[34] + -4.083333333333331 * sp[28] + -0.5833333333333091 * sp[31] + -30.83333333333341 * sp[34] + -18.95833333333344 * sp[35] + -12.4583333333333 * sp[29] + -0.583333333333431 * sp[32] + 9.166666666666739 * sp[28] + 6.875000000000029 * sp[29] + 3.375000000000033 * sp[26] + 1.083333333333323 * sp[27] + 9.166666666666769 * sp[31] + 9.166666666666735 * sp[32] + 0.1666666666666958 * sp[27] + -12.91666666666669 * sp[30];
    A[45] = -1.591666666666686 * sp[33] + -0.9416666666666805 * sp[34] + 0.6916666666666718 * sp[28] + 0.6916666666666675 * sp[31] + -0.6500000000000165 * sp[34] + -1.295833333333349 * sp[35] + 1.52083333333335 * sp[29] + 0.6916666666666721 * sp[32] + -2.283333333333351 * sp[28] + -0.1125000000000015 * sp[29] + -1.09583333333334 * sp[26] + 0.6916666666666641 * sp[27] + -0.6500000000000206 * sp[31] + -0.4666666666666756 * sp[32] + -0.2666666666666524 * sp[27] + 0.5083333333333411 * sp[30];
    A[46] = -0.06666666666666607 * sp[33] + 0.4666666666666789 * sp[34] + 0.03333333333333333 * sp[28] + 0.03333333333333335 * sp[31] + -0.949999999999996 * sp[34] + 1.258333333333345 * sp[35] + -0.708333333333339 * sp[29] + 0.03333333333333974 * sp[32] + 0.31666666666667 * sp[28] + -0.1083333333333369 * sp[29] + 0.8583333333333374 * sp[26] + 0.03333333333331109 * sp[27] + -0.9499999999999899 * sp[31] + 0.6833333333333376 * sp[32] + 0.1166666666666596 * sp[27] + -0.1833333333333422 * sp[30];
    A[47] = -1.008333333333345 * sp[33] + -2.191666666666688 * sp[34] + 1.108333333333346 * sp[28] + 1.108333333333343 * sp[31] + -1.150000000000009 * sp[34] + -3.170833333333346 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333336 * sp[32] + -1.116666666666674 * sp[28] + -1.154166666666679 * sp[29] + 0.3625000000000129 * sp[26] + 1.108333333333356 * sp[27] + -1.150000000000007 * sp[31] + -2.133333333333341 * sp[32] + 0.733333333333346 * sp[27] + 1.091666666666678 * sp[30];
    A[48] = 2.633333333333362 * sp[33] + 2.275000000000022 * sp[34] + 3.241666666666688 * sp[28] + 2.275000000000021 * sp[31] + 2.275000000000022 * sp[34] + 2.775000000000019 * sp[35] + 1.008333333333348 * sp[29] + 1.508333333333348 * sp[32] + 3.241666666666688 * sp[28] + 1.008333333333348 * sp[29] + 10.04166666666666 * sp[26] + 5.508333333333336 * sp[27] + 2.275000000000021 * sp[31] + 1.508333333333348 * sp[32] + 5.508333333333336 * sp[27] + 3.683333333333337 * sp[30];
    A[49] = -2.016666666666687 * sp[33] + -3.13333333333336 * sp[34] + -1.400000000000005 * sp[28] + -3.13333333333335 * sp[31] + -2.300000000000015 * sp[34] + -4.216666666666682 * sp[35] + -0.683333333333337 * sp[29] + -2.600000000000004 * sp[32] + -2.233333333333348 * sp[28] + -1.683333333333353 * sp[29] + -5.083333333333314 * sp[26] + -7.933333333333323 * sp[27] + -2.300000000000011 * sp[31] + -2.766666666666679 * sp[32] + -3.433333333333322 * sp[27] + -5.866666666666662 * sp[30];
    A[50] = -0.03333333333333505 * sp[33] + 0.8583333333333448 * sp[34] + 0.1583333333333319 * sp[28] + 0.8583333333333487 * sp[31] + -0.4749999999999988 * sp[34] + 1.691666666666675 * sp[35] + -1.075 * sp[29] + 1.091666666666679 * sp[32] + 0.1583333333333319 * sp[28] + 0.2583333333333322 * sp[29] + 1.624999999999992 * sp[26] + 2.424999999999994 * sp[27] + -0.474999999999996 * sp[31] + 1.091666666666669 * sp[32] + -0.241666666666667 * sp[27] + 2.183333333333334 * sp[30];
    A[51] = 1.508333333333338 * sp[33] + 1.816666666666673 * sp[34] + 1.816666666666683 * sp[28] + 1.816666666666677 * sp[31] + 0.7750000000000079 * sp[34] + 0.3208333333333349 * sp[35] + 2.270833333333352 * sp[29] + 1.816666666666676 * sp[32] + 4.308333333333317 * sp[28] + 7.504166666666656 * sp[29] + 0.320833333333346 * sp[26] + 1.816666666666674 * sp[27] + 2.591666666666665 * sp[31] + 4.30833333333333 * sp[32] + 0.7750000000000187 * sp[27] + 1.508333333333344 * sp[30];
    A[52] = -2.600000000000013 * sp[33] + -1.383333333333339 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333336 * sp[31] + -1.133333333333352 * sp[34] + -0.2250000000000102 * sp[35] + -2.291666666666688 * sp[29] + -1.383333333333342 * sp[32] + -7.533333333333306 * sp[28] + -5.25833333333332 * sp[29] + 0.9416666666666696 * sp[26] + -1.383333333333325 * sp[27] + -3.933333333333341 * sp[31] + -2.86666666666667 * sp[32] + 0.03333333333331373 * sp[27] + -1.016666666666675 * sp[30];
    A[53] = 1.091666666666673 * sp[33] + -0.01666666666666122 * sp[34] + -0.01666666666666816 * sp[28] + -0.01666666666666899 * sp[31] + 0.3583333333333407 * sp[34] + -0.3874999999999954 * sp[35] + 0.7291666666666731 * sp[29] + -0.01666666666667108 * sp[32] + 3.22499999999999 * sp[28] + 0.9625000000000143 * sp[29] + -1.054166666666675 * sp[26] + -0.01666666666665621 * sp[27] + 1.341666666666673 * sp[31] + 0.5583333333333441 * sp[32] + -0.3083333333333265 * sp[27] + 0.09166666666667274 * sp[30];
    A[54] = -7.54247233265659 * sp[33] + -8.720983634634173 * sp[34] + 4.006938426723798 * sp[28] + 4.006938426723779 * sp[31] + -7.778174593052085 * sp[34] + -8.249579113843097 * sp[35] + 4.478342947514847 * sp[29] + 4.006938426723815 * sp[32] + -8.720983634634148 * sp[28] + -12.96362432175348 * sp[29] + -0.2357022603955099 * sp[26] + 4.006938426723687 * sp[27] + -7.778174593052072 * sp[31] + -11.0780062385893 * sp[32] + 0.2357022603955539 * sp[27] + 2.357022603955162 * sp[30];
    A[55] = -5.917840259193766 * sp[33] + 0.7216878364869758 * sp[34] + 11.98001808568483 * sp[28] + 11.98001808568479 * sp[31] + -0.866025403784465 * sp[34] + -2.237232293109841 * sp[35] + 13.35122497501021 * sp[29] + 11.98001808568483 * sp[32] + -11.83568051838747 * sp[28] + 18.25870226312176 * sp[29] + 2.670244995002079 * sp[26] + 11.98001808568466 * sp[27] + -0.8660254037845676 * sp[31] + 10.96965511460279 * sp[32] + 4.041451884327483 * sp[27] + 8.804591605141834 * sp[30];
    A[56] = -3.583333333333376 * sp[33] + -4.916666666666696 * sp[34] + 6.583333333333417 * sp[28] + 6.583333333333409 * sp[31] + -7.000000000000029 * sp[34] + -7.708333333333317 * sp[35] + 7.291666666666716 * sp[29] + 6.583333333333344 * sp[32] + -2.666666666666681 * sp[28] + 4.4583333333333 * sp[29] + 5.458333333333448 * sp[26] + 6.583333333333519 * sp[27] + -6.999999999999996 * sp[31] + 2.16666666666665 * sp[32] + 6.16666666666673 * sp[27] + 6.916666666666742 * sp[30];
    A[57] = 5.89255650988796 * sp[33] + 7.542472332656563 * sp[34] + -10.84230397819383 * sp[28] + -5.185449728701421 * sp[31] + 9.19238815542516 * sp[34] + 8.36743024404084 * sp[35] + -4.360491817317143 * sp[29] + -5.185449728701446 * sp[32] + 5.421151989096901 * sp[28] + 5.06759859850367 * sp[29] + -18.97403196183907 * sp[26] + -5.185449728701346 * sp[27] + 9.192388155425132 * sp[31] + 5.892556509887933 * sp[32] + -6.835365551470065 * sp[27] + -4.006938426723827 * sp[30];
    A[58] = 16.8874953737967 * sp[33] + 9.526279441628924 * sp[34] + 9.526279441628898 * sp[28] + -1.732050807568821 * sp[31] + 11.69134295109002 * sp[34] + 10.60881119635949 * sp[35] + -0.6495190528382873 * sp[29] + -1.732050807568816 * sp[32] + 22.0836477965033 * sp[28] + 2.814582562299473 * sp[29] + 36.58957330989251 * sp[26] + -1.732050807568818 * sp[27] + 11.69134295109003 * sp[31] + 3.897114317030056 * sp[32] + 19.48557158514985 * sp[27] + 0.4330127018922296 * sp[30];
    A[59] = 10.41666666666678 * sp[33] + 13.33333333333342 * sp[34] + 0.3333333333333051 * sp[28] + 1.833333333333292 * sp[31] + 16.25000000000007 * sp[34] + 14.7916666666667 * sp[35] + 3.291666666666651 * sp[29] + 1.833333333333339 * sp[32] + 9.583333333333403 * sp[28] + 8.958333333333469 * sp[29] + 7.458333333333223 * sp[26] + 1.833333333333262 * sp[27] + 16.25000000000002 * sp[31] + 10.41666666666672 * sp[32] + 9.416666666666604 * sp[27] + 2.916666666666619 * sp[30];
    A[60] = -0.06666666666665499 * sp[33] + 0.8833333333333411 * sp[34] + -0.3833333333333358 * sp[28] + -0.3833333333333392 * sp[31] + -0.5333333333333139 * sp[34] + 1.675000000000006 * sp[35] + -0.9583333333333371 * sp[29] + -0.3833333333333445 * sp[32] + -0.09999999999999265 * sp[28] + 0.1416666666666677 * sp[29] + 0.4416666666666659 * sp[26] + -0.3833333333333362 * sp[27] + -0.533333333333319 * sp[31] + 0.9333333333333247 * sp[32] + -0.1333333333333351 * sp[27] + -0.6000000000000077 * sp[30];
    A[61] = 1.633333333333333 * sp[33] + -1.433333333333342 * sp[34] + 0.4333333333333356 * sp[28] + 0.4333333333333453 * sp[31] + 3.066666666666661 * sp[34] + -3.683333333333337 * sp[35] + 1.583333333333335 * sp[29] + 0.4333333333333413 * sp[32] + 1.199999999999994 * sp[28] + -0.2833333333333317 * sp[29] + -0.2166666666666637 * sp[26] + 0.4333333333333553 * sp[27] + 3.066666666666659 * sp[31] + -2.533333333333316 * sp[32] + 0.9333333333333405 * sp[27] + 1.200000000000033 * sp[30];
    A[62] = 1.266666666666677 * sp[33] + 3.38333333333335 * sp[34] + -1.216666666666678 * sp[28] + -1.216666666666679 * sp[31] + 2.133333333333347 * sp[34] + 7.258333333333349 * sp[35] + -2.375000000000013 * sp[29] + -1.216666666666672 * sp[32] + 0.9000000000000019 * sp[28] + 1.058333333333334 * sp[29] + -0.3083333333333408 * sp[26] + -1.216666666666682 * sp[27] + 2.133333333333342 * sp[31] + 4.933333333333333 * sp[32] + -1.466666666666681 * sp[27] + -2.600000000000027 * sp[30];
    A[63] = -2.016666666666687 * sp[33] + -2.300000000000015 * sp[34] + -2.233333333333348 * sp[28] + -2.300000000000011 * sp[31] + -3.13333333333336 * sp[34] + -4.216666666666682 * sp[35] + -1.683333333333353 * sp[29] + -2.766666666666679 * sp[32] + -1.400000000000005 * sp[28] + -0.683333333333337 * sp[29] + -5.083333333333314 * sp[26] + -3.433333333333322 * sp[27] + -3.13333333333335 * sp[31] + -2.600000000000004 * sp[32] + -7.933333333333323 * sp[27] + -5.866666666666662 * sp[30];
    A[64] = 2.533333333333351 * sp[33] + 4.266666666666687 * sp[34] + 1.800000000000002 * sp[28] + 4.266666666666679 * sp[31] + 4.266666666666687 * sp[34] + 8.766666666666683 * sp[35] + 1.36666666666667 * sp[29] + 5.866666666666671 * sp[32] + 1.800000000000002 * sp[28] + 1.36666666666667 * sp[29] + 3.833333333333313 * sp[26] + 5.866666666666648 * sp[27] + 4.266666666666679 * sp[31] + 5.866666666666671 * sp[32] + 5.866666666666648 * sp[27] + 11.73333333333333 * sp[30];
    A[65] = 0.8166666666666667 * sp[33] + -1.966666666666675 * sp[34] + 1.433333333333338 * sp[28] + -1.966666666666681 * sp[31] + 1.53333333333333 * sp[34] + -4.716666666666671 * sp[35] + 3.15 * sp[29] + -3.100000000000012 * sp[32] + 0.599999999999997 * sp[28] + -0.5166666666666637 * sp[29] + 0.4166666666666717 * sp[26] + -2.433333333333327 * sp[27] + 1.533333333333329 * sp[31] + -3.266666666666652 * sp[32] + 2.066666666666676 * sp[27] + -5.866666666666659 * sp[30];
    A[66] = -1.016666666666665 * sp[33] + -1.383333333333334 * sp[34] + -1.383333333333346 * sp[28] + -1.383333333333342 * sp[31] + 0.03333333333333433 * sp[34] + 0.9416666666666678 * sp[35] + -2.291666666666683 * sp[29] + -1.38333333333334 * sp[32] + -2.86666666666665 * sp[28] + -5.258333333333313 * sp[29] + -0.2250000000000064 * sp[26] + -1.383333333333336 * sp[27] + -3.933333333333317 * sp[31] + -7.533333333333333 * sp[32] + -1.133333333333346 * sp[27] + -2.600000000000011 * sp[30];
    A[67] = 1.200000000000004 * sp[33] + 0.7666666666666736 * sp[34] + 0.7666666666666717 * sp[28] + 0.7666666666666717 * sp[31] + 0.2666666666666774 * sp[34] + -0.3833333333333158 * sp[35] + 1.416666666666675 * sp[29] + 0.7666666666666782 * sp[32] + 3.73333333333331 * sp[28] + 3.016666666666655 * sp[29] + -0.3833333333333314 * sp[26] + 0.7666666666666642 * sp[27] + 5.866666666666648 * sp[31] + 3.733333333333333 * sp[32] + 0.266666666666671 * sp[27] + 1.200000000000002 * sp[30];
    A[68] = -0.1833333333333336 * sp[33] + -0.216666666666686 * sp[34] + -0.2166666666666663 * sp[28] + -0.2166666666666749 * sp[31] + -0.3000000000000015 * sp[34] + 0.5249999999999776 * sp[35] + -1.041666666666666 * sp[29] + -0.2166666666666749 * sp[32] + -0.8666666666666573 * sp[28] + -1.008333333333354 * sp[29] + 0.3583333333333328 * sp[26] + -0.2166666666666806 * sp[27] + -1.933333333333323 * sp[31] + -1.533333333333371 * sp[32] + -0.4666666666666696 * sp[27] + -0.6000000000000215 * sp[30];
    A[69] = 8.0138768534476 * sp[33] + 10.37089945740279 * sp[34] + -0.9428090415820736 * sp[28] + -0.9428090415820467 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977587 * sp[35] + 0.4714045207910094 * sp[29] + -0.9428090415820751 * sp[32] + 5.656854249492392 * sp[28] + 11.78511301977584 * sp[29] + 0.4714045207910345 * sp[26] + -0.9428090415819976 * sp[27] + 13.19932658214893 * sp[31] + 24.51303508113379 * sp[32] + 1.885618083164135 * sp[27];
    A[70] = -1.154700538379177 * sp[33] + -1.443375672973968 * sp[34] + -6.639528095680759 * sp[28] + -6.639528095680701 * sp[31] + 4.618802153517057 * sp[34] + 5.917840259193761 * sp[35] + -7.93856620135745 * sp[29] + -6.639528095680726 * sp[32] + -5.196152422706543 * sp[28] + -14.86676943163269 * sp[29] + -1.010362971081864 * sp[26] + -6.639528095680614 * sp[27] + 4.618802153517121 * sp[31] + -16.16580753730935 * sp[32] + -2.309401076758542 * sp[27] + -10.39230484541319 * sp[30];
    A[71] = 9.666666666666714 * sp[33] + 4.833333333333329 * sp[34] + -8.166666666666753 * sp[28] + -8.166666666666751 * sp[31] + 17.33333333333338 * sp[34] + 24.58333333333332 * sp[35] + -15.41666666666677 * sp[29] + -8.166666666666691 * sp[32] + 6.999999999999992 * sp[28] + -11.41666666666668 * sp[29] + -3.416666666666722 * sp[26] + -8.16666666666678 * sp[27] + 17.33333333333336 * sp[31] + -2.666666666666742 * sp[32] + -10.66666666666678 * sp[27] + -18.00000000000021 * sp[30];
    A[72] = -11.78511301977586 * sp[33] + -8.013876853447591 * sp[34] + 0.4714045207910917 * sp[28] + 3.299831645537275 * sp[31] + -20.74179891480546 * sp[34] + -14.37783788412654 * sp[35] + -3.064129385141602 * sp[29] + 3.299831645537287 * sp[32] + -8.485281374238568 * sp[28] + -3.064129385141726 * sp[29] + 2.592724864350684 * sp[26] + 3.29983164553723 * sp[27] + -20.74179891480543 * sp[31] + -9.428090415820725 * sp[32] + 1.885618083164163 * sp[27] + 5.656854249492379 * sp[30];
    A[73] = -7.794228634060008 * sp[33] + -6.06217782649113 * sp[34] + -6.062177826491119 * sp[28] + -0.8660254037844826 * sp[31] + -10.39230484541332 * sp[34] + -8.227241335952233 * sp[35] + -3.03108891324566 * sp[29] + -0.8660254037844993 * sp[32] + -5.196152422706639 * sp[28] + -1.299038105676682 * sp[29] + -16.88749537379648 * sp[26] + -0.8660254037844755 * sp[27] + -10.39230484541327 * sp[31] + -3.464101615137765 * sp[32] + -17.32050807568874 * sp[27] + 3.464101615137741 * sp[30];
    A[74] = -20.83333333333344 * sp[33] + -14.16666666666675 * sp[34] + -8.166666666666654 * sp[28] + -1.166666666666623 * sp[31] + -36.66666666666677 * sp[34] + -25.41666666666677 * sp[35] + -12.41666666666663 * sp[29] + -1.166666666666715 * sp[32] + -14.99999999999999 * sp[28] + -5.416666666666699 * sp[29] + -12.41666666666659 * sp[26] + -1.166666666666584 * sp[27] + -36.66666666666671 * sp[31] + -16.6666666666668 * sp[32] + -24.6666666666666 * sp[27] + 10.00000000000006 * sp[30];
    A[75] = -1.00833333333333 * sp[33] + 0.1416666666666647 * sp[34] + 0.1083333333333332 * sp[28] + 0.108333333333328 * sp[31] + 1.183333333333324 * sp[34] + -0.8374999999999994 * sp[35] + 1.145833333333343 * sp[29] + 0.1083333333333438 * sp[32] + -2.116666666666668 * sp[28] + 0.5124999999999998 * sp[29] + -0.6375000000000104 * sp[26] + 0.1083333333333224 * sp[27] + 1.183333333333325 * sp[31] + -0.4666666666666625 * sp[32] + 0.4000000000000135 * sp[27] + 0.09166666666667904 * sp[30];
    A[76] = 1.266666666666662 * sp[33] + -0.8666666666666628 * sp[34] + 0.3666666666666669 * sp[28] + 0.3666666666666746 * sp[31] + -2.116666666666662 * sp[34] + 3.008333333333324 * sp[35] + -1.958333333333337 * sp[29] + 0.3666666666666691 * sp[32] + 2.483333333333333 * sp[28] + -2.025000000000003 * sp[29] + 1.275000000000011 * sp[26] + 0.3666666666666751 * sp[27] + -2.116666666666666 * sp[31] + 1.849999999999981 * sp[32] + -1.050000000000007 * sp[27] + -1.016666666666671 * sp[30];
    A[77] = 0.4083333333333339 * sp[33] + 1.391666666666663 * sp[34] + -0.3083333333333346 * sp[28] + -0.3083333333333366 * sp[31] + -0.9833333333333389 * sp[34] + -4.295833333333334 * sp[35] + 1.187500000000008 * sp[29] + -0.3083333333333389 * sp[32] + 0.7166666666666702 * sp[28] + 2.887500000000001 * sp[29] + -0.7625000000000044 * sp[26] + -0.3083333333333356 * sp[27] + -0.9833333333333422 * sp[31] + -2.800000000000002 * sp[32] + 0.7333333333333472 * sp[27] + 1.508333333333342 * sp[30];
    A[78] = -0.03333333333333505 * sp[33] + -0.4749999999999988 * sp[34] + 0.1583333333333319 * sp[28] + -0.474999999999996 * sp[31] + 0.8583333333333448 * sp[34] + 1.691666666666675 * sp[35] + 0.2583333333333322 * sp[29] + 1.091666666666669 * sp[32] + 0.1583333333333319 * sp[28] + -1.075 * sp[29] + 1.624999999999992 * sp[26] + -0.241666666666667 * sp[27] + 0.8583333333333487 * sp[31] + 1.091666666666679 * sp[32] + 2.424999999999994 * sp[27] + 2.183333333333334 * sp[30];
    A[79] = 0.8166666666666667 * sp[33] + 1.53333333333333 * sp[34] + 0.599999999999997 * sp[28] + 1.533333333333329 * sp[31] + -1.966666666666675 * sp[34] + -4.716666666666671 * sp[35] + -0.5166666666666637 * sp[29] + -3.266666666666652 * sp[32] + 1.433333333333338 * sp[28] + 3.15 * sp[29] + 0.4166666666666717 * sp[26] + 2.066666666666676 * sp[27] + -1.966666666666681 * sp[31] + -3.100000000000012 * sp[32] + -2.433333333333327 * sp[27] + -5.866666666666659 * sp[30];
    A[80] = 0.6333333333333295 * sp[33] + -1.058333333333329 * sp[34] + 1.241666666666664 * sp[28] + -1.058333333333332 * sp[31] + -1.058333333333329 * sp[34] + 3.441666666666659 * sp[35] + -2.325000000000002 * sp[29] + 2.174999999999985 * sp[32] + 1.241666666666664 * sp[28] + -2.325000000000002 * sp[29] + 2.708333333333337 * sp[26] + -1.825000000000009 * sp[27] + -1.058333333333332 * sp[31] + 2.174999999999985 * sp[32] + -1.825000000000009 * sp[27] + 3.683333333333309 * sp[30];
    A[81] = 0.09166666666666884 * sp[33] + -0.01666666666666511 * sp[34] + -0.01666666666666829 * sp[28] + -0.01666666666666849 * sp[31] + -0.3083333333333328 * sp[34] + -1.054166666666678 * sp[35] + 0.7291666666666812 * sp[29] + -0.01666666666666394 * sp[32] + 0.5583333333333289 * sp[28] + 0.9624999999999945 * sp[29] + -0.3875000000000051 * sp[26] + -0.01666666666667077 * sp[27] + 1.341666666666666 * sp[31] + 3.225 * sp[32] + 0.3583333333333543 * sp[27] + 1.091666666666682 * sp[30];
    A[82] = -0.5999999999999994 * sp[33] + -0.2166666666666625 * sp[34] + -0.2166666666666657 * sp[28] + -0.2166666666666618 * sp[31] + -0.4666666666666698 * sp[34] + 0.3583333333333215 * sp[35] + -1.041666666666683 * sp[29] + -0.2166666666666798 * sp[32] + -1.533333333333319 * sp[28] + -1.00833333333332 * sp[29] + 0.5250000000000115 * sp[26] + -0.2166666666666549 * sp[27] + -1.933333333333329 * sp[31] + -0.8666666666666767 * sp[32] + -0.3000000000000211 * sp[27] + -0.1833333333333511 * sp[30];
    A[83] = 0.5083333333333336 * sp[33] + -0.1833333333333446 * sp[34] + -0.1833333333333333 * sp[28] + -0.1833333333333404 * sp[31] + 0.7749999999999959 * sp[34] + -1.012499999999997 * sp[35] + 1.604166666666672 * sp[29] + -0.183333333333331 * sp[32] + 0.9749999999999961 * sp[28] + 0.1708333333333166 * sp[29] + -1.01250000000001 * sp[26] + -0.1833333333333428 * sp[27] + 0.591666666666658 * sp[31] + 0.9750000000000059 * sp[32] + 0.7750000000000072 * sp[27] + 0.5083333333333386 * sp[30];
    A[84] = 1.885618083164124 * sp[33] + 3.064129385141721 * sp[34] + 1.649915822768609 * sp[28] + 1.649915822768619 * sp[31] + -5.421151989096885 * sp[34] + -1.178511301977559 * sp[35] + -2.592724864350643 * sp[29] + 1.649915822768654 * sp[32] + 3.06412938514171 * sp[28] + 3.535533905932765 * sp[29] + 2.121320343559642 * sp[26] + 1.649915822768601 * sp[27] + -5.421151989096904 * sp[31] + -13.43502884254444 * sp[32] + -2.121320343559604 * sp[27] + -2.357022603955115 * sp[30];
    A[85] = -4.474464586219574 * sp[33] + -0.7216878364869854 * sp[34] + 1.876388374866274 * sp[28] + 1.876388374866294 * sp[31] + -3.752776749732451 * sp[34] + -0.07216878364872614 * sp[35] + -1.804219591217488 * sp[29] + 1.876388374866334 * sp[32] + -8.948929172439211 * sp[28] + 0.2165063509461329 * sp[29] + 1.948557158514976 * sp[26] + 1.876388374866269 * sp[27] + -3.752776749732437 * sp[31] + 5.196152422706629 * sp[32] + -1.732050807568756 * sp[27] + 1.587713240271573 * sp[30];
    A[86] = 5.583333333333325 * sp[33] + 0.9166666666666461 * sp[34] + -2.583333333333345 * sp[28] + -2.583333333333349 * sp[31] + -10.33333333333335 * sp[34] + -18.95833333333332 * sp[35] + 6.041666666666709 * sp[29] + -2.583333333333395 * sp[32] + 10.66666666666669 * sp[28] + 4.874999999999955 * sp[29] + -4.125000000000011 * sp[26] + -2.583333333333329 * sp[27] + -10.33333333333337 * sp[31] + 0.5 * sp[32] + 4.500000000000073 * sp[27] + 11.08333333333338 * sp[30];
    A[87] = -5.892556509887886 * sp[33] + -1.885618083164133 * sp[34] + -6.128258770283388 * sp[28] + -0.4714045207910259 * sp[31] + 11.54941075938029 * sp[34] + 4.831896338108134 * sp[35] + 6.246109900481125 * sp[29] + -0.4714045207910533 * sp[32] + -11.07800623858926 * sp[28] + -3.181980515339471 * sp[29] + -13.08147545195112 * sp[26] + -0.471404520791004 * sp[27] + 11.54941075938032 * sp[31] + 3.535533905932839 * sp[32] + 4.949747468305802 * sp[27] + -1.649915822768626 * sp[30];
    A[88] = 3.897114317029979 * sp[33] + 0.8660254037844379 * sp[34] + 0.8660254037844323 * sp[28] + -1.732050807568868 * sp[31] + -1.299038105676648 * sp[34] + -0.2165063509460623 * sp[35] + -2.814582562299337 * sp[29] + -1.732050807568821 * sp[32] + 9.093266739736659 * sp[28] + 0.6495190528383281 * sp[29] + 8.443747686898277 * sp[26] + -1.732050807568861 * sp[27] + -1.299038105676625 * sp[31] + -0.4330127018921566 * sp[32] + -2.165063509461034 * sp[27] + -3.897114317029963 * sp[30];
    A[89] = -10.41666666666664 * sp[33] + -3.333333333333341 * sp[34] + -6.333333333333312 * sp[28] + 0.166666666666676 * sp[31] + 20.41666666666669 * sp[34] + 8.541666666666753 * sp[35] + 12.04166666666664 * sp[29] + 0.1666666666668761 * sp[32] + -19.58333333333336 * sp[28] + -5.624999999999998 * sp[29] + -12.12500000000005 * sp[26] + 0.1666666666666656 * sp[27] + 20.41666666666674 * sp[31] + 6.25000000000017 * sp[32] + 15.24999999999998 * sp[27] + -12.91666666666645 * sp[30];
    A[90] = -1.091666666666676 * sp[33] + -0.7333333333333453 * sp[34] + 2.133333333333354 * sp[28] + 1.149999999999997 * sp[31] + -1.108333333333343 * sp[34] + -0.3624999999999972 * sp[35] + 1.154166666666663 * sp[29] + 1.116666666666658 * sp[32] + -1.108333333333344 * sp[28] + -1.479166666666688 * sp[29] + 3.170833333333359 * sp[26] + 1.149999999999999 * sp[27] + -1.10833333333334 * sp[31] + -1.108333333333343 * sp[32] + 2.19166666666667 * sp[27] + 1.008333333333327 * sp[30];
    A[91] = 0.1833333333333412 * sp[33] + -0.1166666666666597 * sp[34] + -0.6833333333333478 * sp[28] + 0.9499999999999993 * sp[31] + -0.03333333333332658 * sp[34] + -0.8583333333333436 * sp[35] + 0.108333333333329 * sp[29] + -0.3166666666666963 * sp[32] + -0.0333333333333333 * sp[28] + 0.7083333333333544 * sp[29] + -1.258333333333349 * sp[26] + 0.9500000000000139 * sp[27] + -0.03333333333333377 * sp[31] + -0.03333333333332655 * sp[32] + -0.4666666666666694 * sp[27] + 0.06666666666666185 * sp[30];
    A[92] = -0.5083333333333329 * sp[33] + 0.2666666666666687 * sp[34] + 0.4666666666666748 * sp[28] + 0.650000000000005 * sp[31] + -0.6916666666666673 * sp[34] + 1.095833333333339 * sp[35] + 0.1125000000000073 * sp[29] + 2.283333333333365 * sp[32] + -0.6916666666666738 * sp[28] + -1.520833333333349 * sp[29] + 1.295833333333344 * sp[26] + 0.6499999999999986 * sp[27] + -0.6916666666666715 * sp[31] + -0.6916666666666719 * sp[32] + 0.9416666666666725 * sp[27] + 1.591666666666679 * sp[30];
    A[93] = 1.508333333333338 * sp[33] + 0.7750000000000079 * sp[34] + 4.308333333333317 * sp[28] + 2.591666666666665 * sp[31] + 1.816666666666673 * sp[34] + 0.3208333333333349 * sp[35] + 7.504166666666656 * sp[29] + 4.30833333333333 * sp[32] + 1.816666666666683 * sp[28] + 2.270833333333352 * sp[29] + 0.320833333333346 * sp[26] + 0.7750000000000187 * sp[27] + 1.816666666666677 * sp[31] + 1.816666666666676 * sp[32] + 1.816666666666674 * sp[27] + 1.508333333333344 * sp[30];
    A[94] = -1.016666666666665 * sp[33] + 0.03333333333333433 * sp[34] + -2.86666666666665 * sp[28] + -3.933333333333317 * sp[31] + -1.383333333333334 * sp[34] + 0.9416666666666678 * sp[35] + -5.258333333333313 * sp[29] + -7.533333333333333 * sp[32] + -1.383333333333346 * sp[28] + -2.291666666666683 * sp[29] + -0.2250000000000064 * sp[26] + -1.133333333333346 * sp[27] + -1.383333333333342 * sp[31] + -1.38333333333334 * sp[32] + -1.383333333333336 * sp[27] + -2.600000000000011 * sp[30];
    A[95] = 0.09166666666666884 * sp[33] + -0.3083333333333328 * sp[34] + 0.5583333333333289 * sp[28] + 1.341666666666666 * sp[31] + -0.01666666666666511 * sp[34] + -1.054166666666678 * sp[35] + 0.9624999999999945 * sp[29] + 3.225 * sp[32] + -0.01666666666666829 * sp[28] + 0.7291666666666812 * sp[29] + -0.3875000000000051 * sp[26] + 0.3583333333333543 * sp[27] + -0.01666666666666849 * sp[31] + -0.01666666666666394 * sp[32] + -0.01666666666667077 * sp[27] + 1.091666666666682 * sp[30];
    A[96] = 3.68333333333333 * sp[33] + 5.508333333333319 * sp[34] + 1.508333333333346 * sp[28] + 2.275000000000001 * sp[31] + 5.508333333333319 * sp[34] + 10.04166666666667 * sp[35] + 1.008333333333335 * sp[29] + 3.241666666666672 * sp[32] + 1.508333333333346 * sp[28] + 1.008333333333335 * sp[29] + 2.775000000000018 * sp[26] + 2.275000000000006 * sp[27] + 2.275000000000001 * sp[31] + 3.241666666666672 * sp[32] + 2.275000000000006 * sp[27] + 2.633333333333337 * sp[30];
    A[97] = -5.866666666666665 * sp[33] + -3.433333333333322 * sp[34] + -2.766666666666689 * sp[28] + -2.299999999999994 * sp[31] + -7.93333333333331 * sp[34] + -5.083333333333314 * sp[35] + -1.683333333333327 * sp[29] + -2.233333333333314 * sp[32] + -2.600000000000026 * sp[28] + -0.6833333333333387 * sp[29] + -4.216666666666695 * sp[26] + -2.300000000000002 * sp[27] + -3.133333333333334 * sp[31] + -1.399999999999997 * sp[32] + -3.133333333333336 * sp[27] + -2.016666666666657 * sp[30];
    A[98] = 2.183333333333337 * sp[33] + -0.2416666666666639 * sp[34] + 1.091666666666683 * sp[28] + -0.4750000000000033 * sp[31] + 2.424999999999993 * sp[34] + 1.625000000000028 * sp[35] + 0.2583333333333336 * sp[29] + 0.1583333333333453 * sp[32] + 1.09166666666668 * sp[28] + -1.075000000000003 * sp[29] + 1.691666666666684 * sp[26] + -0.475000000000012 * sp[27] + 0.8583333333333328 * sp[31] + 0.1583333333333465 * sp[32] + 0.8583333333333348 * sp[27] + -0.0333333333333353 * sp[30];
    A[99] = -4.006938426723779 * sp[33] + -6.835365551469969 * sp[34] + 5.892556509887916 * sp[28] + 9.192388155425105 * sp[31] + -5.185449728701363 * sp[34] + -18.97403196183917 * sp[35] + 5.067598598503558 * sp[29] + 5.421151989096735 * sp[32] + -5.185449728701403 * sp[28] + -4.360491817317074 * sp[29] + 8.367430244040849 * sp[26] + 9.192388155425164 * sp[27] + -5.185449728701386 * sp[31] + -10.84230397819382 * sp[32] + 7.542472332656505 * sp[27] + 5.892556509887861 * sp[30];
    A[100] = 2.742413778650655 * sp[33] + 17.89785834487829 * sp[34] + 10.96965511460294 * sp[28] + 19.91858428704207 * sp[31] + 0.7216878364868249 * sp[34] + 24.75389279150502 * sp[35] + 9.165435523385279 * sp[29] + 19.34123401785233 * sp[32] + 0.7216878364870016 * sp[28] + 2.525907427704591 * sp[29] + 18.1143646958246 * sp[26] + 19.91858428704217 * sp[27] + 0.7216878364869705 * sp[31] + 5.051814855409156 * sp[32] + 16.31014510460695 * sp[27] + 17.46484564298616 * sp[30];
    A[101] = -1.083333333333306 * sp[33] + 12.16666666666668 * sp[34] + -1.833333333333325 * sp[28] + 2.000000000000047 * sp[31] + -2.416666666666646 * sp[34] + 27.95833333333339 * sp[35] + -2.041666666666603 * sp[29] + 14.3333333333336 * sp[32] + -2.416666666666698 * sp[28] + -2.208333333333336 * sp[29] + 1.791666666666687 * sp[26] + 1.999999999999994 * sp[27] + -2.41666666666669 * sp[31] + 8.083333333333396 * sp[32] + 1.583333333333372 * sp[27] + 9.41666666666678 * sp[30];
    A[102] = 2.357022603955137 * sp[33] + 0.2357022603954957 * sp[34] + -11.07800623858928 * sp[28] + -7.778174593052079 * sp[31] + 4.006938426723758 * sp[34] + -0.2357022603954908 * sp[35] + -12.96362432175338 * sp[29] + -8.720983634634079 * sp[32] + 4.006938426723811 * sp[28] + 4.478342947514799 * sp[29] + -8.249579113843126 * sp[26] + -7.778174593052131 * sp[27] + 4.0069384267238 * sp[31] + 4.006938426723776 * sp[32] + -8.720983634634113 * sp[27] + -7.542472332656562 * sp[30];
    A[103] = 10.39230484541331 * sp[33] + 7.361215932167808 * sp[34] + 7.361215932167607 * sp[28] + -6.495190528383215 * sp[31] + 11.69134295108997 * sp[34] + 6.062177826491085 * sp[35] + 12.99038105676646 * sp[29] + -8.227241335952131 * sp[32] + 11.69134295109 * sp[28] + 12.9903810567667 * sp[29] + -7.794228634059967 * sp[26] + -6.495190528383206 * sp[27] + 11.69134295108997 * sp[31] + 11.69134295108998 * sp[32] + -3.897114317029985 * sp[27] + -6.06217782649099 * sp[30];
    A[104] = 4.166666666666629 * sp[33] + 0.4166666666666368 * sp[34] + 8.416666666666629 * sp[28] + 2.749999999999916 * sp[31] + 7.083333333333313 * sp[34] + -0.4166666666666101 * sp[35] + 13.58333333333326 * sp[29] + -8.91666666666692 * sp[32] + 7.083333333333408 * sp[28] + 7.916666666666662 * sp[29] + 1.916666666666703 * sp[26] + 2.749999999999953 * sp[27] + 7.083333333333388 * sp[31] + 7.083333333333349 * sp[32] + 3.083333333333331 * sp[27] + -3.333333333333458 * sp[30];
    A[105] = 2.600000000000015 * sp[33] + 1.466666666666684 * sp[34] + -4.933333333333373 * sp[28] + -2.133333333333324 * sp[31] + 1.216666666666667 * sp[34] + 0.3083333333333415 * sp[35] + -1.058333333333334 * sp[29] + -0.899999999999993 * sp[32] + 1.216666666666674 * sp[28] + 2.375000000000031 * sp[29] + -7.258333333333392 * sp[26] + -2.133333333333329 * sp[27] + 1.216666666666664 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333335 * sp[27] + -1.266666666666654 * sp[30];
    A[106] = -1.200000000000006 * sp[33] + -0.9333333333333425 * sp[34] + 2.533333333333362 * sp[28] + -3.066666666666676 * sp[31] + -0.4333333333333288 * sp[34] + 0.2166666666666536 * sp[35] + 0.28333333333334 * sp[29] + -1.199999999999983 * sp[32] + -0.4333333333333354 * sp[28] + -1.583333333333361 * sp[29] + 3.683333333333372 * sp[26] + -3.066666666666699 * sp[27] + -0.4333333333333275 * sp[31] + -0.4333333333333506 * sp[32] + 1.43333333333334 * sp[27] + -1.63333333333333 * sp[30];
    A[107] = 0.6000000000000019 * sp[33] + 0.1333333333333392 * sp[34] + -0.9333333333333506 * sp[28] + 0.5333333333333297 * sp[31] + 0.3833333333333367 * sp[34] + -0.4416666666666523 * sp[35] + -0.141666666666675 * sp[29] + 0.09999999999998632 * sp[32] + 0.383333333333336 * sp[28] + 0.9583333333333421 * sp[29] + -1.675000000000014 * sp[26] + 0.5333333333333468 * sp[27] + 0.383333333333336 * sp[31] + 0.3833333333333452 * sp[32] + -0.8833333333333382 * sp[27] + 0.06666666666666388 * sp[30];
    A[108] = -2.600000000000013 * sp[33] + -1.133333333333352 * sp[34] + -7.533333333333306 * sp[28] + -3.933333333333341 * sp[31] + -1.383333333333339 * sp[34] + -0.2250000000000102 * sp[35] + -5.25833333333332 * sp[29] + -2.86666666666667 * sp[32] + -1.383333333333342 * sp[28] + -2.291666666666688 * sp[29] + 0.9416666666666696 * sp[26] + 0.03333333333331373 * sp[27] + -1.383333333333336 * sp[31] + -1.383333333333342 * sp[32] + -1.383333333333325 * sp[27] + -1.016666666666675 * sp[30];
    A[109] = 1.200000000000004 * sp[33] + 0.2666666666666774 * sp[34] + 3.73333333333331 * sp[28] + 5.866666666666648 * sp[31] + 0.7666666666666736 * sp[34] + -0.3833333333333158 * sp[35] + 3.016666666666655 * sp[29] + 3.733333333333333 * sp[32] + 0.7666666666666717 * sp[28] + 1.416666666666675 * sp[29] + -0.3833333333333314 * sp[26] + 0.266666666666671 * sp[27] + 0.7666666666666717 * sp[31] + 0.7666666666666782 * sp[32] + 0.7666666666666642 * sp[27] + 1.200000000000002 * sp[30];
    A[110] = -0.5999999999999994 * sp[33] + -0.4666666666666698 * sp[34] + -1.533333333333319 * sp[28] + -1.933333333333329 * sp[31] + -0.2166666666666625 * sp[34] + 0.3583333333333215 * sp[35] + -1.00833333333332 * sp[29] + -0.8666666666666767 * sp[32] + -0.2166666666666657 * sp[28] + -1.041666666666683 * sp[29] + 0.5250000000000115 * sp[26] + -0.3000000000000211 * sp[27] + -0.2166666666666618 * sp[31] + -0.2166666666666798 * sp[32] + -0.2166666666666549 * sp[27] + -0.1833333333333511 * sp[30];
    A[111] = -5.866666666666665 * sp[33] + -7.93333333333331 * sp[34] + -2.600000000000026 * sp[28] + -3.133333333333334 * sp[31] + -3.433333333333322 * sp[34] + -5.083333333333314 * sp[35] + -0.6833333333333387 * sp[29] + -1.399999999999997 * sp[32] + -2.766666666666689 * sp[28] + -1.683333333333327 * sp[29] + -4.216666666666695 * sp[26] + -3.133333333333336 * sp[27] + -2.299999999999994 * sp[31] + -2.233333333333314 * sp[32] + -2.300000000000002 * sp[27] + -2.016666666666657 * sp[30];
    A[112] = 11.73333333333334 * sp[33] + 5.866666666666646 * sp[34] + 5.86666666666671 * sp[28] + 4.266666666666653 * sp[31] + 5.866666666666646 * sp[34] + 3.833333333333314 * sp[35] + 1.366666666666667 * sp[29] + 1.799999999999984 * sp[32] + 5.86666666666671 * sp[28] + 1.366666666666667 * sp[29] + 8.766666666666728 * sp[26] + 4.266666666666665 * sp[27] + 4.266666666666653 * sp[31] + 1.799999999999984 * sp[32] + 4.266666666666665 * sp[27] + 2.533333333333312 * sp[30];
    A[113] = -5.866666666666673 * sp[33] + 2.066666666666678 * sp[34] + -3.266666666666699 * sp[28] + 1.533333333333347 * sp[31] + -2.433333333333325 * sp[34] + 0.4166666666666539 * sp[35] + -0.5166666666666702 * sp[29] + 0.5999999999999934 * sp[32] + -3.100000000000023 * sp[28] + 3.150000000000019 * sp[29] + -4.716666666666711 * sp[26] + 1.53333333333336 * sp[27] + -1.96666666666666 * sp[31] + 1.433333333333325 * sp[32] + -1.966666666666671 * sp[27] + 0.8166666666666706 * sp[30];
    A[114] = 5.656854249492413 * sp[33] + 1.885618083164144 * sp[34] + -9.42809041582067 * sp[28] + -20.74179891480538 * sp[31] + 3.299831645537251 * sp[34] + 2.592724864350741 * sp[35] + -3.064129385141686 * sp[29] + -8.485281374238479 * sp[32] + 3.299831645537251 * sp[28] + -3.064129385141733 * sp[29] + -14.37783788412652 * sp[26] + -20.74179891480548 * sp[27] + 3.299831645537243 * sp[31] + 0.4714045207910673 * sp[32] + -8.01387685344751 * sp[27] + -11.78511301977572 * sp[30];
    A[115] = 10.39230484541333 * sp[33] + -30.02221399786041 * sp[34] + -16.16580753730963 * sp[28] + -36.95041722813605 * sp[31] + -1.443375672973982 * sp[34] + -19.1968964505549 * sp[35] + -5.340489990004033 * sp[29] + -15.58845726811977 * sp[32] + -1.443375672974099 * sp[28] + -12.26869322027954 * sp[29] + -26.12509968083069 * sp[26] + -36.95041722813618 * sp[27] + -1.443375672974046 * sp[31] + -10.10362971081833 * sp[32] + -15.29978213352506 * sp[27] + -21.93931022920567 * sp[30];
    A[116] = -2.00000000000002 * sp[33] + -2.666666666666621 * sp[34] + 5.333333333333309 * sp[28] + 9.333333333333284 * sp[31] + -0.166666666666642 * sp[34] + -8.416666666666643 * sp[35] + 1.583333333333274 * sp[29] + 2.999999999999883 * sp[32] + -0.1666666666666589 * sp[28] + 3.583333333333329 * sp[29] + 5.583333333333375 * sp[26] + 9.333333333333423 * sp[27] + -0.166666666666635 * sp[31] + -1.166666666666667 * sp[32] + 1.833333333333303 * sp[27] + 3.666666666666617 * sp[30];
    A[117] = 1.885618083164114 * sp[34] + 24.51303508113369 * sp[28] + 13.19932658214896 * sp[31] + -0.9428090415820983 * sp[34] + 0.4714045207910194 * sp[35] + 11.78511301977576 * sp[29] + 5.656854249492394 * sp[32] + -0.9428090415820742 * sp[28] + 0.471404520791078 * sp[29] + 11.78511301977585 * sp[26] + 13.19932658214904 * sp[27] + -0.9428090415820977 * sp[31] + -0.9428090415820516 * sp[32] + 10.37089945740266 * sp[27] + 8.013876853447574 * sp[30];
    A[118] = -20.78460969082661 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541307 * sp[28] + 17.32050807568864 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137792 * sp[35] + -17.32050807568868 * sp[29] + 3.46410161513765 * sp[32] + -10.39230484541332 * sp[28] + -17.32050807568895 * sp[29] + 24.24871130596444 * sp[26] + 17.32050807568864 * sp[27] + -10.39230484541325 * sp[31] + -10.39230484541331 * sp[32] + 3.464101615137805 * sp[27] + 7.794228634059789 * sp[30];
    A[119] = 3.333333333333304 * sp[34] + -12.66666666666664 * sp[28] + -4.666666666666607 * sp[31] + -1.66666666666673 * sp[34] + 0.8333333333333073 * sp[35] + -7.166666666666652 * sp[29] + -7.999999999999865 * sp[32] + -1.666666666666686 * sp[28] + 0.833333333333409 * sp[29] + -7.166666666666755 * sp[26] + -4.666666666666631 * sp[27] + -1.666666666666729 * sp[31] + -1.666666666666649 * sp[32] + -3.666666666666684 * sp[27] + -5.833333333333224 * sp[30];
    A[120] = -1.508333333333343 * sp[33] + -0.7333333333333383 * sp[34] + 2.80000000000002 * sp[28] + 0.9833333333333276 * sp[31] + 0.3083333333333489 * sp[34] + 0.7625000000000086 * sp[35] + -2.887500000000019 * sp[29] + -0.7166666666666621 * sp[32] + 0.3083333333333351 * sp[28] + -1.187500000000012 * sp[29] + 4.295833333333376 * sp[26] + 0.9833333333333349 * sp[27] + 0.3083333333333472 * sp[31] + 0.3083333333333431 * sp[32] + -1.391666666666689 * sp[27] + -0.4083333333333348 * sp[30];
    A[121] = 1.016666666666671 * sp[33] + 1.049999999999997 * sp[34] + -1.850000000000012 * sp[28] + 2.116666666666678 * sp[31] + -0.3666666666666903 * sp[34] + -1.275000000000004 * sp[35] + 2.025000000000008 * sp[29] + -2.483333333333346 * sp[32] + -0.3666666666666667 * sp[28] + 1.958333333333343 * sp[29] + -3.008333333333365 * sp[26] + 2.116666666666685 * sp[27] + -0.3666666666666819 * sp[31] + -0.3666666666666688 * sp[32] + 0.8666666666666748 * sp[27] + -1.266666666666676 * sp[30];
    A[122] = -0.09166666666666645 * sp[33] + -0.399999999999999 * sp[34] + 0.4666666666666736 * sp[28] + -1.183333333333336 * sp[31] + -0.1083333333333435 * sp[34] + 0.6374999999999835 * sp[35] + -0.5124999999999966 * sp[29] + 2.116666666666683 * sp[32] + -0.1083333333333331 * sp[28] + -1.145833333333334 * sp[29] + 0.8375000000000081 * sp[26] + -1.183333333333344 * sp[27] + -0.1083333333333378 * sp[31] + -0.108333333333341 * sp[32] + -0.1416666666666689 * sp[27] + 1.008333333333338 * sp[30];
    A[123] = 1.091666666666673 * sp[33] + 0.3583333333333407 * sp[34] + 3.22499999999999 * sp[28] + 1.341666666666673 * sp[31] + -0.01666666666666122 * sp[34] + -0.3874999999999954 * sp[35] + 0.9625000000000143 * sp[29] + 0.5583333333333441 * sp[32] + -0.01666666666666816 * sp[28] + 0.7291666666666731 * sp[29] + -1.054166666666675 * sp[26] + -0.3083333333333265 * sp[27] + -0.01666666666666899 * sp[31] + -0.01666666666667108 * sp[32] + -0.01666666666665621 * sp[27] + 0.09166666666667274 * sp[30];
    A[124] = -0.1833333333333336 * sp[33] + -0.3000000000000015 * sp[34] + -0.8666666666666573 * sp[28] + -1.933333333333323 * sp[31] + -0.216666666666686 * sp[34] + 0.5249999999999776 * sp[35] + -1.008333333333354 * sp[29] + -1.533333333333371 * sp[32] + -0.2166666666666663 * sp[28] + -1.041666666666666 * sp[29] + 0.3583333333333328 * sp[26] + -0.4666666666666696 * sp[27] + -0.2166666666666749 * sp[31] + -0.2166666666666749 * sp[32] + -0.2166666666666806 * sp[27] + -0.6000000000000215 * sp[30];
    A[125] = 0.5083333333333336 * sp[33] + 0.7749999999999959 * sp[34] + 0.9749999999999961 * sp[28] + 0.591666666666658 * sp[31] + -0.1833333333333446 * sp[34] + -1.012499999999997 * sp[35] + 0.1708333333333166 * sp[29] + 0.9750000000000059 * sp[32] + -0.1833333333333333 * sp[28] + 1.604166666666672 * sp[29] + -1.01250000000001 * sp[26] + 0.7750000000000072 * sp[27] + -0.1833333333333404 * sp[31] + -0.183333333333331 * sp[32] + -0.1833333333333428 * sp[27] + 0.5083333333333386 * sp[30];
    A[126] = 2.183333333333337 * sp[33] + 2.424999999999993 * sp[34] + 1.09166666666668 * sp[28] + 0.8583333333333328 * sp[31] + -0.2416666666666639 * sp[34] + 1.625000000000028 * sp[35] + -1.075000000000003 * sp[29] + 0.1583333333333465 * sp[32] + 1.091666666666683 * sp[28] + 0.2583333333333336 * sp[29] + 1.691666666666684 * sp[26] + 0.8583333333333348 * sp[27] + -0.4750000000000033 * sp[31] + 0.1583333333333453 * sp[32] + -0.475000000000012 * sp[27] + -0.0333333333333353 * sp[30];
    A[127] = -5.866666666666673 * sp[33] + -2.433333333333325 * sp[34] + -3.100000000000023 * sp[28] + -1.96666666666666 * sp[31] + 2.066666666666678 * sp[34] + 0.4166666666666539 * sp[35] + 3.150000000000019 * sp[29] + 1.433333333333325 * sp[32] + -3.266666666666699 * sp[28] + -0.5166666666666702 * sp[29] + -4.716666666666711 * sp[26] + -1.966666666666671 * sp[27] + 1.533333333333347 * sp[31] + 0.5999999999999934 * sp[32] + 1.53333333333336 * sp[27] + 0.8166666666666706 * sp[30];
    A[128] = 3.683333333333338 * sp[33] + -1.825000000000014 * sp[34] + 2.175000000000015 * sp[28] + -1.058333333333344 * sp[31] + -1.825000000000014 * sp[34] + 2.708333333333343 * sp[35] + -2.325000000000013 * sp[29] + 1.241666666666676 * sp[32] + 2.175000000000015 * sp[28] + -2.325000000000013 * sp[29] + 3.441666666666703 * sp[26] + -1.058333333333346 * sp[27] + -1.058333333333344 * sp[31] + 1.241666666666676 * sp[32] + -1.058333333333346 * sp[27] + 0.6333333333333399 * sp[30];
    A[129] = -1.649915822768621 * sp[33] + 4.949747468305842 * sp[34] + 3.535533905932765 * sp[28] + 11.54941075938029 * sp[31] + -0.47140452079108 * sp[34] + -13.08147545195123 * sp[35] + -3.181980515339489 * sp[29] + -11.07800623858925 * sp[32] + -0.4714045207910265 * sp[28] + 6.246109900481202 * sp[29] + 4.831896338108107 * sp[26] + 11.54941075938034 * sp[27] + -0.4714045207910456 * sp[31] + -6.128258770283451 * sp[32] + -1.885618083164176 * sp[27] + -5.892556509887932 * sp[30];
    A[130] = -13.13471862406399 * sp[33] + 12.12435565298212 * sp[34] + 5.196152422706699 * sp[28] + 17.03183294109398 * sp[31] + -0.7216878364868893 * sp[34] + -6.278684177437054 * sp[35] + -4.54663336986833 * sp[29] + -12.41303078757691 * sp[32] + -0.7216878364869717 * sp[28] + 9.021097956087939 * sp[29] + 7.289047148519089 * sp[26] + 17.03183294109404 * sp[27] + -0.7216878364869486 * sp[31] + -5.05181485540916 * sp[32] + -2.453738644055995 * sp[27] + -7.072540797572969 * sp[30];
    A[131] = 3.083333333333355 * sp[33] + -9.500000000000037 * sp[34] + -3.500000000000002 * sp[28] + -11.33333333333335 * sp[31] + -1.583333333333446 * sp[34] + 13.37500000000008 * sp[35] + 3.375000000000073 * sp[29] + 17.66666666666679 * sp[32] + -1.583333333333336 * sp[28] + -8.458333333333329 * sp[29] + -4.458333333333382 * sp[26] + -11.33333333333342 * sp[27] + -1.5833333333334 * sp[31] + 3.916666666666705 * sp[32] + 2.416666666666706 * sp[27] + 8.583333333333378 * sp[30];
    A[132] = -2.357022603955175 * sp[33] + -2.121320343559623 * sp[34] + -13.43502884254444 * sp[28] + -5.421151989096878 * sp[31] + 1.649915822768734 * sp[34] + 2.121320343559714 * sp[35] + 3.535533905932827 * sp[29] + 3.064129385141735 * sp[32] + 1.649915822768609 * sp[28] + -2.592724864350699 * sp[29] + -1.178511301977585 * sp[26] + -5.421151989096925 * sp[27] + 1.649915822768678 * sp[31] + 1.649915822768641 * sp[32] + 3.06412938514179 * sp[27] + 1.885618083164171 * sp[30];
    A[133] = 10.39230484541332 * sp[33] + 3.031088913245595 * sp[34] + 3.031088913245462 * sp[28] + -10.82531754730543 * sp[31] + -1.299038105676695 * sp[34] + -2.598076211353359 * sp[35] + 4.33012701892233 * sp[29] + 4.763139720814379 * sp[32] + -1.299038105676687 * sp[28] + 4.330127018922266 * sp[29] + -16.45448267190447 * sp[26] + -10.82531754730546 * sp[27] + -1.299038105676727 * sp[31] + -1.299038105676734 * sp[32] + 0.4330127018923423 * sp[27] + 2.598076211353328 * sp[30];
    A[134] = -4.166666666666693 * sp[33] + -3.749999999999966 * sp[34] + 4.249999999999979 * sp[28] + 1.916666666666696 * sp[31] + 2.916666666666885 * sp[34] + 3.750000000000129 * sp[35] + -2.249999999999899 * sp[29] + -13.08333333333323 * sp[32] + 2.91666666666666 * sp[28] + -4.583333333333377 * sp[29] + 9.416666666666758 * sp[26] + 1.916666666666689 * sp[27] + 2.916666666666785 * sp[31] + 2.916666666666719 * sp[32] + -1.083333333333268 * sp[27] + -6.666666666666608 * sp[30];
    A[135] = 1.64991582276867 * sp[33] + 3.064129385141741 * sp[34] + -1.649915822768626 * sp[28] + -1.649915822768629 * sp[31] + 0.4714045207910607 * sp[34] + 1.767766952966356 * sp[35] + 5.06759859850362 * sp[29] + -0.2357022603955397 * sp[32] + -5.185449728701379 * sp[28] + -3.889087296526077 * sp[29] + 10.72445284799603 * sp[26] + 4.006938426723743 * sp[27] + -5.185449728701382 * sp[31] + -5.185449728701427 * sp[32] + 17.44196726926825 * sp[27] + 5.892556509887854 * sp[30];
    A[136] = 3.771236166328243 * sp[33] + -3.771236166328278 * sp[34] + 0.9428090415820636 * sp[28] + 0.9428090415820866 * sp[31] + 6.128258770283439 * sp[34] + 1.178511301977611 * sp[35] + -5.421151989096877 * sp[29] + 12.25651754056689 * sp[32] + 3.299831645537233 * sp[28] + -1.649915822768556 * sp[29] + -2.5927248643507 * sp[26] + 3.771236166328306 * sp[27] + 3.299831645537254 * sp[31] + 3.299831645537296 * sp[32] + -8.956685895029654 * sp[27] + 11.78511301977581 * sp[30];
    A[137] = 4.006938426723806 * sp[33] + 10.13519719700723 * sp[34] + -4.00693842672381 * sp[28] + -4.006938426723808 * sp[31] + 5.185449728701402 * sp[34] + 7.660323462854311 * sp[35] + -3.181980515339506 * sp[29] + -16.73486048808173 * sp[32] + -0.4714045207910367 * sp[28] + 2.003469213361863 * sp[29] + 2.474873734152935 * sp[26] + 1.649915822768597 * sp[27] + -0.4714045207910216 * sp[31] + -0.4714045207910476 * sp[32] + 3.299831645537245 * sp[27] + -5.892556509887908 * sp[30];
    A[138] = -7.54247233265659 * sp[33] + -7.778174593052085 * sp[34] + -8.720983634634148 * sp[28] + -7.778174593052072 * sp[31] + -8.720983634634173 * sp[34] + -8.249579113843097 * sp[35] + -12.96362432175348 * sp[29] + -11.0780062385893 * sp[32] + 4.006938426723798 * sp[28] + 4.478342947514847 * sp[29] + -0.2357022603955099 * sp[26] + 0.2357022603955539 * sp[27] + 4.006938426723779 * sp[31] + 4.006938426723815 * sp[32] + 4.006938426723687 * sp[27] + 2.357022603955162 * sp[30];
    A[139] = 8.0138768534476 * sp[33] + 13.19932658214896 * sp[34] + 5.656854249492392 * sp[28] + 13.19932658214893 * sp[31] + 10.37089945740279 * sp[34] + 11.78511301977587 * sp[35] + 11.78511301977584 * sp[29] + 24.51303508113379 * sp[32] + -0.9428090415820736 * sp[28] + 0.4714045207910094 * sp[29] + 0.4714045207910345 * sp[26] + 1.885618083164135 * sp[27] + -0.9428090415820467 * sp[31] + -0.9428090415820751 * sp[32] + -0.9428090415819976 * sp[27];
    A[140] = 1.885618083164124 * sp[33] + -5.421151989096885 * sp[34] + 3.06412938514171 * sp[28] + -5.421151989096904 * sp[31] + 3.064129385141721 * sp[34] + -1.178511301977559 * sp[35] + 3.535533905932765 * sp[29] + -13.43502884254444 * sp[32] + 1.649915822768609 * sp[28] + -2.592724864350643 * sp[29] + 2.121320343559642 * sp[26] + -2.121320343559604 * sp[27] + 1.649915822768619 * sp[31] + 1.649915822768654 * sp[32] + 1.649915822768601 * sp[27] + -2.357022603955115 * sp[30];
    A[141] = -4.006938426723779 * sp[33] + -5.185449728701363 * sp[34] + -5.185449728701403 * sp[28] + -5.185449728701386 * sp[31] + -6.835365551469969 * sp[34] + -18.97403196183917 * sp[35] + -4.360491817317074 * sp[29] + -10.84230397819382 * sp[32] + 5.892556509887916 * sp[28] + 5.067598598503558 * sp[29] + 8.367430244040849 * sp[26] + 7.542472332656505 * sp[27] + 9.192388155425105 * sp[31] + 5.421151989096735 * sp[32] + 9.192388155425164 * sp[27] + 5.892556509887861 * sp[30];
    A[142] = 5.656854249492413 * sp[33] + 3.299831645537251 * sp[34] + 3.299831645537251 * sp[28] + 3.299831645537243 * sp[31] + 1.885618083164144 * sp[34] + 2.592724864350741 * sp[35] + -3.064129385141733 * sp[29] + 0.4714045207910673 * sp[32] + -9.42809041582067 * sp[28] + -3.064129385141686 * sp[29] + -14.37783788412652 * sp[26] + -8.01387685344751 * sp[27] + -20.74179891480538 * sp[31] + -8.485281374238479 * sp[32] + -20.74179891480548 * sp[27] + -11.78511301977572 * sp[30];
    A[143] = -1.649915822768621 * sp[33] + -0.47140452079108 * sp[34] + -0.4714045207910265 * sp[28] + -0.4714045207910456 * sp[31] + 4.949747468305842 * sp[34] + -13.08147545195123 * sp[35] + 6.246109900481202 * sp[29] + -6.128258770283451 * sp[32] + 3.535533905932765 * sp[28] + -3.181980515339489 * sp[29] + 4.831896338108107 * sp[26] + -1.885618083164176 * sp[27] + 11.54941075938029 * sp[31] + -11.07800623858925 * sp[32] + 11.54941075938034 * sp[27] + -5.892556509887932 * sp[30];
    A[144] = 26.66666666666691 * sp[33] + 33.33333333333363 * sp[34] + -6.666666666666757 * sp[28] + -6.666666666666673 * sp[31] + 33.33333333333363 * sp[34] + 113.333333333334 * sp[35] + -6.666666666666645 * sp[29] + 33.33333333333336 * sp[32] + -6.666666666666757 * sp[28] + -6.666666666666645 * sp[29] + 33.33333333333341 * sp[26] + 33.33333333333341 * sp[27] + -6.666666666666673 * sp[31] + 33.33333333333336 * sp[32] + 33.33333333333341 * sp[27] + 66.66666666666652 * sp[30];
    A[145] = 4.082482904638894 * sp[33] + -4.082482904638368 * sp[34] + -28.57738033247073 * sp[28] + -28.57738033247055 * sp[31] + 8.164965809277462 * sp[34] + 14.28869016623508 * sp[35] + -34.70110468942849 * sp[29] + -4.082482904638915 * sp[32] + 8.164965809277174 * sp[28] + 14.28869016623505 * sp[29] + 63.27848502189896 * sp[26] + 69.40220937885684 * sp[27] + 8.1649658092769 * sp[31] + 57.15476066494009 * sp[32] + 57.15476066494102 * sp[27] + 102.0620726159655 * sp[30];
    A[146] = 25.92724864350687 * sp[33] + 16.49915822768608 * sp[34] + -25.92724864350702 * sp[28] + -25.92724864350701 * sp[31] + 37.71236166328286 * sp[34] + -64.81812160876726 * sp[35] + -36.53385036130537 * sp[29] + -124.9221980096242 * sp[32] + 9.428090415820652 * sp[28] + 20.03469213361883 * sp[29] + -8.249579113843064 * sp[26] + 2.357022603955116 * sp[27] + 9.428090415820773 * sp[31] + -18.85618083164145 * sp[32] + -18.85618083164132 * sp[27] + -58.92556509887896 * sp[30];
    A[147] = -33.33333333333352 * sp[33] + -26.66666666666686 * sp[34] + 13.33333333333365 * sp[28] + 13.33333333333356 * sp[31] + -46.66666666666705 * sp[34] + -36.66666666666701 * sp[35] + 3.333333333333485 * sp[29] + 13.33333333333345 * sp[32] + -6.666666666666664 * sp[28] + 3.333333333333238 * sp[29] + -36.66666666666684 * sp[26] + -26.66666666666696 * sp[27] + -6.666666666666805 * sp[31] + -6.66666666666683 * sp[32] + -46.66666666666679 * sp[27] + -33.33333333333359 * sp[30];
    A[148] = -36.74234614174804 * sp[33] + -24.49489742783207 * sp[34] + -24.49489742783202 * sp[28] + -36.74234614174792 * sp[34] + -30.6186217847898 * sp[35] + -6.123724356958409 * sp[29] + 36.74234614174794 * sp[28] + 42.86607049870598 * sp[29] + -30.61862178478984 * sp[26] + -24.49489742783143 * sp[27] + 36.74234614174783 * sp[31] + 36.74234614174809 * sp[32] + -12.24744871391659 * sp[27] + -36.74234614174713 * sp[30];
    A[149] = -58.92556509887928 * sp[33] + -47.14045207910346 * sp[34] + -18.85618083164115 * sp[28] + -4.714045207910223 * sp[31] + -82.4957911384312 * sp[34] + -64.81812160876746 * sp[35] + -22.39171473757409 * sp[29] + 80.13876853447553 * sp[32] + -11.78511301977577 * sp[28] + 5.892556509887761 * sp[29] + -8.249579113843081 * sp[26] + 9.428090415820426 * sp[27] + -11.78511301977603 * sp[31] + -11.78511301977606 * sp[32] + 16.49915822768592 * sp[27] + 54.21151989096802 * sp[30];
    A[150] = 10.96965511460294 * sp[33] + 0.1443375672973164 * sp[34] + 0.7216878364870876 * sp[28] + 0.721687836487058 * sp[31] + 0.7216878364869928 * sp[34] + -1.732050807568889 * sp[35] + 11.54700538379252 * sp[29] + 5.051814855409178 * sp[32] + -10.53664241271074 * sp[28] + -8.660254037844531 * sp[29] + 18.47520861406814 * sp[26] + 7.64989106676251 * sp[27] + -10.53664241271075 * sp[31] + -10.5366424127108 * sp[32] + 29.30052616137364 * sp[27] + 10.96965511460282 * sp[30];
    A[151] = -8.94892917243917 * sp[33] + -3.175426480542766 * sp[34] + 1.443375672974 * sp[28] + 1.443375672973959 * sp[31] + -1.443375672973968 * sp[34] + 2.020725942163698 * sp[35] + -7.216878364870358 * sp[29] + 10.10362971081832 * sp[32] + 3.752776749732578 * sp[28] + -1.443375672973925 * sp[29] + -3.752776749732627 * sp[26] + 4.90747728811191 * sp[27] + 3.752776749732621 * sp[31] + 3.752776749732673 * sp[32] + -12.41303078757703 * sp[27] + 14.14508159514585 * sp[30];
    A[152] = -0.5773502691895879 * sp[33] + 4.474464586219606 * sp[34] + -0.7216878364870476 * sp[28] + -0.7216878364870314 * sp[31] + -0.7216878364869815 * sp[34] + 4.04145188432746 * sp[35] + -5.051814855409166 * sp[32] + -3.319764047840382 * sp[28] + -2.886751345948217 * sp[29] + 6.928203230275564 * sp[26] + 6.206515393788468 * sp[27] + -3.319764047840352 * sp[31] + -3.319764047840376 * sp[32] + 7.649891066762593 * sp[27] + -0.5773502691895933 * sp[30];
    A[153] = -5.917840259193766 * sp[33] + -0.866025403784465 * sp[34] + -11.83568051838747 * sp[28] + -0.8660254037845676 * sp[31] + 0.7216878364869758 * sp[34] + -2.237232293109841 * sp[35] + 18.25870226312176 * sp[29] + 10.96965511460279 * sp[32] + 11.98001808568483 * sp[28] + 13.35122497501021 * sp[29] + 2.670244995002079 * sp[26] + 4.041451884327483 * sp[27] + 11.98001808568479 * sp[31] + 11.98001808568483 * sp[32] + 11.98001808568466 * sp[27] + 8.804591605141834 * sp[30];
    A[154] = -1.154700538379177 * sp[33] + 4.618802153517057 * sp[34] + -5.196152422706543 * sp[28] + 4.618802153517121 * sp[31] + -1.443375672973968 * sp[34] + 5.917840259193761 * sp[35] + -14.86676943163269 * sp[29] + -16.16580753730935 * sp[32] + -6.639528095680759 * sp[28] + -7.93856620135745 * sp[29] + -1.010362971081864 * sp[26] + -2.309401076758542 * sp[27] + -6.639528095680701 * sp[31] + -6.639528095680726 * sp[32] + -6.639528095680614 * sp[27] + -10.39230484541319 * sp[30];
    A[155] = -4.474464586219574 * sp[33] + -3.752776749732451 * sp[34] + -8.948929172439211 * sp[28] + -3.752776749732437 * sp[31] + -0.7216878364869854 * sp[34] + -0.07216878364872614 * sp[35] + 0.2165063509461329 * sp[29] + 5.196152422706629 * sp[32] + 1.876388374866274 * sp[28] + -1.804219591217488 * sp[29] + 1.948557158514976 * sp[26] + -1.732050807568756 * sp[27] + 1.876388374866294 * sp[31] + 1.876388374866334 * sp[32] + 1.876388374866269 * sp[27] + 1.587713240271573 * sp[30];
    A[156] = 2.742413778650655 * sp[33] + 0.7216878364868249 * sp[34] + 0.7216878364870016 * sp[28] + 0.7216878364869705 * sp[31] + 17.89785834487829 * sp[34] + 24.75389279150502 * sp[35] + 2.525907427704591 * sp[29] + 5.051814855409156 * sp[32] + 10.96965511460294 * sp[28] + 9.165435523385279 * sp[29] + 18.1143646958246 * sp[26] + 16.31014510460695 * sp[27] + 19.91858428704207 * sp[31] + 19.34123401785233 * sp[32] + 19.91858428704217 * sp[27] + 17.46484564298616 * sp[30];
    A[157] = 10.39230484541333 * sp[33] + -1.443375672973982 * sp[34] + -1.443375672974099 * sp[28] + -1.443375672974046 * sp[31] + -30.02221399786041 * sp[34] + -19.1968964505549 * sp[35] + -12.26869322027954 * sp[29] + -10.10362971081833 * sp[32] + -16.16580753730963 * sp[28] + -5.340489990004033 * sp[29] + -26.12509968083069 * sp[26] + -15.29978213352506 * sp[27] + -36.95041722813605 * sp[31] + -15.58845726811977 * sp[32] + -36.95041722813618 * sp[27] + -21.93931022920567 * sp[30];
    A[158] = -13.13471862406399 * sp[33] + -0.7216878364868893 * sp[34] + -0.7216878364869717 * sp[28] + -0.7216878364869486 * sp[31] + 12.12435565298212 * sp[34] + -6.278684177437054 * sp[35] + 9.021097956087939 * sp[29] + -5.05181485540916 * sp[32] + 5.196152422706699 * sp[28] + -4.54663336986833 * sp[29] + 7.289047148519089 * sp[26] + -2.453738644055995 * sp[27] + 17.03183294109398 * sp[31] + -12.41303078757691 * sp[32] + 17.03183294109404 * sp[27] + -7.072540797572969 * sp[30];
    A[159] = 4.082482904638894 * sp[33] + 8.164965809277462 * sp[34] + 8.164965809277174 * sp[28] + 8.1649658092769 * sp[31] + -4.082482904638368 * sp[34] + 14.28869016623508 * sp[35] + 14.28869016623505 * sp[29] + 57.15476066494009 * sp[32] + -28.57738033247073 * sp[28] + -34.70110468942849 * sp[29] + 63.27848502189896 * sp[26] + 57.15476066494102 * sp[27] + -28.57738033247055 * sp[31] + -4.082482904638915 * sp[32] + 69.40220937885684 * sp[27] + 102.0620726159655 * sp[30];
    A[160] = 189.9999999999995 * sp[33] + 57.49999999999878 * sp[34] + 12.49999999999968 * sp[28] + 12.49999999999924 * sp[31] + 57.49999999999878 * sp[34] + 132.4999999999985 * sp[35] + 12.49999999999971 * sp[29] + 87.49999999999882 * sp[32] + 12.49999999999968 * sp[28] + 12.49999999999971 * sp[29] + 132.5000000000005 * sp[26] + 132.5000000000004 * sp[27] + 12.49999999999924 * sp[31] + 87.49999999999882 * sp[32] + 132.5000000000004 * sp[27] + 189.9999999999996 * sp[30];
    A[161] = -31.75426480542925 * sp[33] + 105.3664241271068 * sp[34] + -7.216878364870563 * sp[28] + -7.216878364870396 * sp[31] + -7.216878364869833 * sp[34] + 57.73502691896249 * sp[35] + -28.86751345948137 * sp[29] + -50.5181485540917 * sp[32] + 1.443375672973954 * sp[28] + 23.09401076758496 * sp[29] + 5.773502691896381 * sp[26] + 27.42413778650724 * sp[27] + 1.443375672974205 * sp[31] + 10.10362971081845 * sp[32] + -15.87713240271464 * sp[27] + -31.75426480542902 * sp[30];
    A[162] = 28.57738033247017 * sp[33] + -4.082482904639336 * sp[34] + 69.40220937885695 * sp[28] + -4.08248290463899 * sp[31] + 8.164965809276723 * sp[34] + -22.45365597551278 * sp[35] + -22.4536559755125 * sp[29] + -28.57738033247038 * sp[32] + 8.164965809277442 * sp[28] + 26.536138880151 * sp[29] + -71.44345083117648 * sp[26] + -53.07227776030287 * sp[27] + 8.164965809277151 * sp[31] + 8.164965809277081 * sp[32] + -89.8146239020502 * sp[27] + -69.40220937885728 * sp[30];
    A[163] = -67.50000000000063 * sp[33] + 7.500000000000099 * sp[34] + 7.499999999998792 * sp[28] + 52.50000000000028 * sp[31] + 3.750000000000028 * sp[35] + 48.74999999999876 * sp[29] + -22.49999999999964 * sp[32] + 90.00000000000063 * sp[28] + 93.75000000000078 * sp[29] + -41.25000000000006 * sp[26] + -37.49999999999935 * sp[27] + 90.00000000000045 * sp[31] + 90.00000000000078 * sp[32] + -30.00000000000092 * sp[27] + -67.49999999999909 * sp[30];
    A[164] = 50.51814855409177 * sp[33] + -7.216878364871526 * sp[34] + 44.74464586219604 * sp[28] + 105.3664241271053 * sp[31] + 14.43375672973967 * sp[34] + -39.6928310067873 * sp[35] + 72.89047148518964 * sp[29] + 62.06515393788319 * sp[32] + 14.43375672974099 * sp[28] + 46.90970937165695 * sp[29] + -13.7120688932536 * sp[26] + 18.76388374866237 * sp[27] + 14.43375672974047 * sp[31] + 14.43375672974036 * sp[32] + 31.75426480542912 * sp[27] + 50.51814855409098 * sp[30];
    A[165] = -6.833333333333318 * sp[33] + 2.41666666666667 * sp[34] + 0.08333333333333279 * sp[28] + 0.08333333333329296 * sp[31] + 1.583333333333388 * sp[34] + 3.749999999999962 * sp[35] + -4.916666666666656 * sp[29] + 0.5833333333333346 * sp[32] + 0.08333333333330284 * sp[28] + -1.250000000000008 * sp[29] + -5.916666666666716 * sp[26] + -0.9166666666666398 * sp[27] + 0.0833333333333135 * sp[31] + 0.08333333333337523 * sp[32] + -10.91666666666675 * sp[27] + -1.833333333333307 * sp[30];
    A[166] = 11.16666666666667 * sp[33] + -8.166666666666679 * sp[34] + 3.166666666666681 * sp[28] + 3.166666666666751 * sp[31] + 1.833333333333293 * sp[34] + -16.66666666666664 * sp[35] + 10.66666666666665 * sp[29] + -7.833333333333412 * sp[32] + -5.166666666666692 * sp[28] + 3.333333333333362 * sp[29] + 2.666666666666698 * sp[26] + -4.833333333333386 * sp[27] + -5.1666666666667 * sp[31] + -5.166666666666742 * sp[32] + 10.16666666666673 * sp[27] + -17.16666666666674 * sp[30];
    A[167] = 4.833333333333365 * sp[33] + 14.91666666666671 * sp[34] + -4.083333333333369 * sp[28] + -4.083333333333384 * sp[31] + 2.416666666666668 * sp[34] + 22.91666666666667 * sp[35] + -5.749999999999993 * sp[29] + 11.41666666666677 * sp[32] + -4.083333333333382 * sp[28] + -12.08333333333342 * sp[29] + 3.25000000000003 * sp[26] + 4.916666666666716 * sp[27] + -4.083333333333384 * sp[31] + -4.083333333333334 * sp[32] + 1.583333333333345 * sp[27] + 19.83333333333346 * sp[30];
    A[168] = -3.583333333333376 * sp[33] + -7.000000000000029 * sp[34] + -2.666666666666681 * sp[28] + -6.999999999999996 * sp[31] + -4.916666666666696 * sp[34] + -7.708333333333317 * sp[35] + 4.4583333333333 * sp[29] + 2.16666666666665 * sp[32] + 6.583333333333417 * sp[28] + 7.291666666666716 * sp[29] + 5.458333333333448 * sp[26] + 6.16666666666673 * sp[27] + 6.583333333333409 * sp[31] + 6.583333333333344 * sp[32] + 6.583333333333519 * sp[27] + 6.916666666666742 * sp[30];
    A[169] = 9.666666666666714 * sp[33] + 17.33333333333338 * sp[34] + 6.999999999999992 * sp[28] + 17.33333333333336 * sp[31] + 4.833333333333329 * sp[34] + 24.58333333333332 * sp[35] + -11.41666666666668 * sp[29] + -2.666666666666742 * sp[32] + -8.166666666666753 * sp[28] + -15.41666666666677 * sp[29] + -3.416666666666722 * sp[26] + -10.66666666666678 * sp[27] + -8.166666666666751 * sp[31] + -8.166666666666691 * sp[32] + -8.16666666666678 * sp[27] + -18.00000000000021 * sp[30];
    A[170] = 5.583333333333325 * sp[33] + -10.33333333333335 * sp[34] + 10.66666666666669 * sp[28] + -10.33333333333337 * sp[31] + 0.9166666666666461 * sp[34] + -18.95833333333332 * sp[35] + 4.874999999999955 * sp[29] + 0.5 * sp[32] + -2.583333333333345 * sp[28] + 6.041666666666709 * sp[29] + -4.125000000000011 * sp[26] + 4.500000000000073 * sp[27] + -2.583333333333349 * sp[31] + -2.583333333333395 * sp[32] + -2.583333333333329 * sp[27] + 11.08333333333338 * sp[30];
    A[171] = -1.083333333333306 * sp[33] + -2.416666666666646 * sp[34] + -2.416666666666698 * sp[28] + -2.41666666666669 * sp[31] + 12.16666666666668 * sp[34] + 27.95833333333339 * sp[35] + -2.208333333333336 * sp[29] + 8.083333333333396 * sp[32] + -1.833333333333325 * sp[28] + -2.041666666666603 * sp[29] + 1.791666666666687 * sp[26] + 1.583333333333372 * sp[27] + 2.000000000000047 * sp[31] + 14.3333333333336 * sp[32] + 1.999999999999994 * sp[27] + 9.41666666666678 * sp[30];
    A[172] = -2.00000000000002 * sp[33] + -0.166666666666642 * sp[34] + -0.1666666666666589 * sp[28] + -0.166666666666635 * sp[31] + -2.666666666666621 * sp[34] + -8.416666666666643 * sp[35] + 3.583333333333329 * sp[29] + -1.166666666666667 * sp[32] + 5.333333333333309 * sp[28] + 1.583333333333274 * sp[29] + 5.583333333333375 * sp[26] + 1.833333333333303 * sp[27] + 9.333333333333284 * sp[31] + 2.999999999999883 * sp[32] + 9.333333333333423 * sp[27] + 3.666666666666617 * sp[30];
    A[173] = 3.083333333333355 * sp[33] + -1.583333333333446 * sp[34] + -1.583333333333336 * sp[28] + -1.5833333333334 * sp[31] + -9.500000000000037 * sp[34] + 13.37500000000008 * sp[35] + -8.458333333333329 * sp[29] + 3.916666666666705 * sp[32] + -3.500000000000002 * sp[28] + 3.375000000000073 * sp[29] + -4.458333333333382 * sp[26] + 2.416666666666706 * sp[27] + -11.33333333333335 * sp[31] + 17.66666666666679 * sp[32] + -11.33333333333342 * sp[27] + 8.583333333333378 * sp[30];
    A[174] = 25.92724864350687 * sp[33] + 37.71236166328286 * sp[34] + 9.428090415820652 * sp[28] + 9.428090415820773 * sp[31] + 16.49915822768608 * sp[34] + -64.81812160876726 * sp[35] + 20.03469213361883 * sp[29] + -18.85618083164145 * sp[32] + -25.92724864350702 * sp[28] + -36.53385036130537 * sp[29] + -8.249579113843064 * sp[26] + -18.85618083164132 * sp[27] + -25.92724864350701 * sp[31] + -124.9221980096242 * sp[32] + 2.357022603955116 * sp[27] + -58.92556509887896 * sp[30];
    A[175] = -31.75426480542925 * sp[33] + -7.216878364869833 * sp[34] + 1.443375672973954 * sp[28] + 1.443375672974205 * sp[31] + 105.3664241271068 * sp[34] + 57.73502691896249 * sp[35] + 23.09401076758496 * sp[29] + 10.10362971081845 * sp[32] + -7.216878364870563 * sp[28] + -28.86751345948137 * sp[29] + 5.773502691896381 * sp[26] + -15.87713240271464 * sp[27] + -7.216878364870396 * sp[31] + -50.5181485540917 * sp[32] + 27.42413778650724 * sp[27] + -31.75426480542902 * sp[30];
    A[176] = 53.33333333333351 * sp[33] + 14.16666666666655 * sp[34] + -30.83333333333362 * sp[28] + -30.83333333333364 * sp[31] + 14.16666666666655 * sp[34] + 219.1666666666673 * sp[35] + -30.83333333333332 * sp[29] + 84.16666666666748 * sp[32] + -30.83333333333362 * sp[28] + -30.83333333333332 * sp[29] + 39.16666666666703 * sp[26] + 39.16666666666701 * sp[27] + -30.83333333333364 * sp[31] + 84.16666666666748 * sp[32] + 39.16666666666701 * sp[27] + 153.3333333333343 * sp[30];
    A[177] = -58.92556509887915 * sp[33] + -25.92724864350692 * sp[34] + -40.06938426723763 * sp[28] + 2.357022603955262 * sp[31] + -18.85618083164113 * sp[34] + -22.39171473757419 * sp[35] + 5.892556509888195 * sp[29] + -11.785113019776 * sp[32] + 37.71236166328288 * sp[28] + 34.17682775735006 * sp[29] + 5.892556509887715 * sp[26] + 2.357022603955055 * sp[27] + 37.71236166328291 * sp[31] + 37.71236166328286 * sp[32] + 9.428090415820463 * sp[27] + -2.357022603955219 * sp[30];
    A[178] = 12.99038105676665 * sp[33] + -4.330127018922268 * sp[34] + -4.330127018922251 * sp[28] + -12.99038105676665 * sp[31] + -25.98076211353322 * sp[34] + 10.82531754730567 * sp[35] + 2.165063509460655 * sp[29] + 12.99038105676659 * sp[32] + 25.9807621135334 * sp[28] + 10.82531754730554 * sp[29] + 36.80607966083918 * sp[26] + 21.65063509461097 * sp[27] + 25.98076211353341 * sp[31] + 25.98076211353309 * sp[32] + -8.660254037843547 * sp[27] + 12.9903810567662 * sp[30];
    A[179] = -104.1666666666669 * sp[33] + -45.83333333333361 * sp[34] + -55.83333333333331 * sp[28] + -0.8333333333331903 * sp[31] + -33.3333333333331 * sp[34] + -39.58333333333351 * sp[35] + 5.416666666666925 * sp[29] + -25.83333333333406 * sp[32] + 66.66666666666728 * sp[28] + 60.41666666666707 * sp[29] + 5.416666666666713 * sp[26] + -0.8333333333333997 * sp[27] + 66.66666666666733 * sp[31] + 66.66666666666723 * sp[32] + -3.333333333333183 * sp[27] + -104.1666666666668 * sp[30];
    A[180] = 5.892556509887862 * sp[33] + -3.299831645537233 * sp[34] + 0.4714045207910328 * sp[28] + 0.4714045207910744 * sp[31] + -1.649915822768637 * sp[34] + -2.474873734152932 * sp[35] + -2.003469213361922 * sp[29] + 0.4714045207910322 * sp[32] + 16.7348604880817 * sp[28] + 3.181980515339542 * sp[29] + -7.66032346285431 * sp[26] + -5.185449728701299 * sp[27] + 4.006938426723815 * sp[31] + 4.006938426723855 * sp[32] + -10.1351971970073 * sp[27] + -4.006938426723782 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029619 * sp[34] + -3.299831645537232 * sp[28] + -3.299831645537309 * sp[31] + -3.771236166328264 * sp[34] + 2.592724864350733 * sp[35] + 1.649915822768618 * sp[29] + -3.299831645537271 * sp[32] + -12.25651754056682 * sp[28] + 5.42115198909681 * sp[29] + -1.178511301977578 * sp[26] + -6.128258770283493 * sp[27] + -0.942809041582064 * sp[31] + -0.9428090415821044 * sp[32] + 3.771236166328301 * sp[27] + -3.771236166328308 * sp[30];
    A[182] = -5.892556509887935 * sp[33] + -17.44196726926823 * sp[34] + 5.185449728701391 * sp[28] + 5.185449728701407 * sp[31] + -4.006938426723802 * sp[34] + -10.72445284799605 * sp[35] + 3.889087296526031 * sp[29] + 5.185449728701387 * sp[32] + 0.2357022603955443 * sp[28] + -5.067598598503512 * sp[29] + -1.76776695296641 * sp[26] + -0.4714045207910393 * sp[27] + 1.649915822768639 * sp[31] + 1.649915822768651 * sp[32] + -3.06412938514176 * sp[27] + -1.649915822768623 * sp[30];
    A[183] = 5.89255650988796 * sp[33] + 9.19238815542516 * sp[34] + 5.421151989096901 * sp[28] + 9.192388155425132 * sp[31] + 7.542472332656563 * sp[34] + 8.36743024404084 * sp[35] + 5.06759859850367 * sp[29] + 5.892556509887933 * sp[32] + -10.84230397819383 * sp[28] + -4.360491817317143 * sp[29] + -18.97403196183907 * sp[26] + -6.835365551470065 * sp[27] + -5.185449728701421 * sp[31] + -5.185449728701446 * sp[32] + -5.185449728701346 * sp[27] + -4.006938426723827 * sp[30];
    A[184] = -11.78511301977586 * sp[33] + -20.74179891480546 * sp[34] + -8.485281374238568 * sp[28] + -20.74179891480543 * sp[31] + -8.013876853447591 * sp[34] + -14.37783788412654 * sp[35] + -3.064129385141726 * sp[29] + -9.428090415820725 * sp[32] + 0.4714045207910917 * sp[28] + -3.064129385141602 * sp[29] + 2.592724864350684 * sp[26] + 1.885618083164163 * sp[27] + 3.299831645537275 * sp[31] + 3.299831645537287 * sp[32] + 3.29983164553723 * sp[27] + 5.656854249492379 * sp[30];
    A[185] = -5.892556509887886 * sp[33] + 11.54941075938029 * sp[34] + -11.07800623858926 * sp[28] + 11.54941075938032 * sp[31] + -1.885618083164133 * sp[34] + 4.831896338108134 * sp[35] + -3.181980515339471 * sp[29] + 3.535533905932839 * sp[32] + -6.128258770283388 * sp[28] + 6.246109900481125 * sp[29] + -13.08147545195112 * sp[26] + 4.949747468305802 * sp[27] + -0.4714045207910259 * sp[31] + -0.4714045207910533 * sp[32] + -0.471404520791004 * sp[27] + -1.649915822768626 * sp[30];
    A[186] = 2.357022603955137 * sp[33] + 4.006938426723758 * sp[34] + 4.006938426723811 * sp[28] + 4.0069384267238 * sp[31] + 0.2357022603954957 * sp[34] + -0.2357022603954908 * sp[35] + 4.478342947514799 * sp[29] + 4.006938426723776 * sp[32] + -11.07800623858928 * sp[28] + -12.96362432175338 * sp[29] + -8.249579113843126 * sp[26] + -8.720983634634113 * sp[27] + -7.778174593052079 * sp[31] + -8.720983634634079 * sp[32] + -7.778174593052131 * sp[27] + -7.542472332656562 * sp[30];
    A[187] = -0.9428090415820983 * sp[34] + -0.9428090415820742 * sp[28] + -0.9428090415820977 * sp[31] + 1.885618083164114 * sp[34] + 0.4714045207910194 * sp[35] + 0.471404520791078 * sp[29] + -0.9428090415820516 * sp[32] + 24.51303508113369 * sp[28] + 11.78511301977576 * sp[29] + 11.78511301977585 * sp[26] + 10.37089945740266 * sp[27] + 13.19932658214896 * sp[31] + 5.656854249492394 * sp[32] + 13.19932658214904 * sp[27] + 8.013876853447574 * sp[30];
    A[188] = -2.357022603955175 * sp[33] + 1.649915822768734 * sp[34] + 1.649915822768609 * sp[28] + 1.649915822768678 * sp[31] + -2.121320343559623 * sp[34] + 2.121320343559714 * sp[35] + -2.592724864350699 * sp[29] + 1.649915822768641 * sp[32] + -13.43502884254444 * sp[28] + 3.535533905932827 * sp[29] + -1.178511301977585 * sp[26] + 3.06412938514179 * sp[27] + -5.421151989096878 * sp[31] + 3.064129385141735 * sp[32] + -5.421151989096925 * sp[27] + 1.885618083164171 * sp[30];
    A[189] = -33.33333333333352 * sp[33] + -46.66666666666705 * sp[34] + -6.666666666666664 * sp[28] + -6.666666666666805 * sp[31] + -26.66666666666686 * sp[34] + -36.66666666666701 * sp[35] + 3.333333333333238 * sp[29] + -6.66666666666683 * sp[32] + 13.33333333333365 * sp[28] + 3.333333333333485 * sp[29] + -36.66666666666684 * sp[26] + -46.66666666666679 * sp[27] + 13.33333333333356 * sp[31] + 13.33333333333345 * sp[32] + -26.66666666666696 * sp[27] + -33.33333333333359 * sp[30];
    A[190] = 28.57738033247017 * sp[33] + 8.164965809276723 * sp[34] + 8.164965809277442 * sp[28] + 8.164965809277151 * sp[31] + -4.082482904639336 * sp[34] + -22.45365597551278 * sp[35] + 26.536138880151 * sp[29] + 8.164965809277081 * sp[32] + 69.40220937885695 * sp[28] + -22.4536559755125 * sp[29] + -71.44345083117648 * sp[26] + -89.8146239020502 * sp[27] + -4.08248290463899 * sp[31] + -28.57738033247038 * sp[32] + -53.07227776030287 * sp[27] + -69.40220937885728 * sp[30];
    A[191] = -58.92556509887915 * sp[33] + -18.85618083164113 * sp[34] + 37.71236166328288 * sp[28] + 37.71236166328291 * sp[31] + -25.92724864350692 * sp[34] + -22.39171473757419 * sp[35] + 34.17682775735006 * sp[29] + 37.71236166328286 * sp[32] + -40.06938426723763 * sp[28] + 5.892556509888195 * sp[29] + 5.892556509887715 * sp[26] + 9.428090415820463 * sp[27] + 2.357022603955262 * sp[31] + -11.785113019776 * sp[32] + 2.357022603955055 * sp[27] + -2.357022603955219 * sp[30];
    A[192] = 66.66666666666688 * sp[33] + 33.33333333333355 * sp[34] + 33.33333333333317 * sp[28] + -6.66666666666683 * sp[31] + 33.33333333333355 * sp[34] + 33.33333333333344 * sp[35] + -6.666666666666814 * sp[29] + -6.666666666666753 * sp[32] + 33.33333333333317 * sp[28] + -6.666666666666814 * sp[29] + 113.3333333333337 * sp[26] + 33.33333333333361 * sp[27] + -6.66666666666683 * sp[31] + -6.666666666666753 * sp[32] + 33.33333333333361 * sp[27] + 26.66666666666712 * sp[30];
    A[193] = 12.24744871391604 * sp[34] + 12.24744871391604 * sp[28] + 12.24744871391601 * sp[31] + 36.7423461417478 * sp[34] + 24.49489742783175 * sp[35] + 24.49489742783193 * sp[29] + 12.24744871391586 * sp[32] + -110.2270384252438 * sp[28] + -48.98979485566409 * sp[29] + -48.98979485566366 * sp[26] + 36.74234614174728 * sp[27] + -36.7423461417481 * sp[31] + -36.74234614174834 * sp[32] + 12.24744871391601 * sp[27] + 24.4948974278314 * sp[30];
    A[194] = 117.8511301977583 * sp[33] + 58.92556509887928 * sp[34] + 58.92556509887891 * sp[28] + 2.357022603954984 * sp[31] + 58.92556509887934 * sp[34] + 58.9255650988791 * sp[35] + 2.357022603955152 * sp[29] + 2.357022603954547 * sp[32] + 58.92556509887859 * sp[28] + -11.78511301977607 * sp[29] + 44.78342947514815 * sp[26] + -11.78511301977572 * sp[27] + -11.78511301977608 * sp[31] + -11.78511301977596 * sp[32] + -11.78511301977583 * sp[27] + -9.428090415820879 * sp[30];
    A[195] = -16.8874953737967 * sp[33] + -5.196152422706716 * sp[34] + 5.19615242270666 * sp[28] + 5.196152422706604 * sp[31] + -7.361215932167809 * sp[34] + -6.278684177437307 * sp[35] + 11.90784930203618 * sp[29] + 5.196152422706644 * sp[32] + -7.361215932167783 * sp[28] + 4.979646071760508 * sp[29] + -21.86714144555723 * sp[26] + -1.732050807568879 * sp[27] + 3.897114317029937 * sp[31] + 3.897114317029912 * sp[32] + -15.15544456622758 * sp[27] + -3.897114317029875 * sp[30];
    A[196] = 7.794228634060001 * sp[33] + -2.598076211353285 * sp[34] + 2.598076211353352 * sp[28] + 2.598076211353382 * sp[31] + 1.732050807568896 * sp[34] + -0.4330127018921326 * sp[35] + -2.16506350946115 * sp[29] + 2.598076211353414 * sp[32] + 1.732050807568883 * sp[28] + -5.629165124598778 * sp[29] + 13.42339375865891 * sp[26] + -0.866025403784632 * sp[27] + -3.464101615137746 * sp[31] + -3.464101615137689 * sp[32] + 8.660254037844371 * sp[27] + -5.196152422706595 * sp[30];
    A[197] = -3.897114317030008 * sp[33] + -5.196152422706669 * sp[34] + 5.196152422706673 * sp[28] + 5.196152422706654 * sp[31] + -3.031088913245569 * sp[34] + -4.113620667976133 * sp[35] + 5.412658773652797 * sp[29] + 5.196152422706625 * sp[32] + -3.031088913245561 * sp[28] + -1.515544456622875 * sp[29] + -2.381569860407188 * sp[26] + -1.732050807568767 * sp[27] + -0.4330127018922425 * sp[31] + -0.4330127018922674 * sp[32] + -2.165063509461068 * sp[27] + 0.4330127018922019 * sp[30];
    A[198] = 16.8874953737967 * sp[33] + 11.69134295109002 * sp[34] + 22.0836477965033 * sp[28] + 11.69134295109003 * sp[31] + 9.526279441628924 * sp[34] + 10.60881119635949 * sp[35] + 2.814582562299473 * sp[29] + 3.897114317030056 * sp[32] + 9.526279441628898 * sp[28] + -0.6495190528382873 * sp[29] + 36.58957330989251 * sp[26] + 19.48557158514985 * sp[27] + -1.732050807568821 * sp[31] + -1.732050807568816 * sp[32] + -1.732050807568818 * sp[27] + 0.4330127018922296 * sp[30];
    A[199] = -7.794228634060008 * sp[33] + -10.39230484541332 * sp[34] + -5.196152422706639 * sp[28] + -10.39230484541327 * sp[31] + -6.06217782649113 * sp[34] + -8.227241335952233 * sp[35] + -1.299038105676682 * sp[29] + -3.464101615137765 * sp[32] + -6.062177826491119 * sp[28] + -3.03108891324566 * sp[29] + -16.88749537379648 * sp[26] + -17.32050807568874 * sp[27] + -0.8660254037844826 * sp[31] + -0.8660254037844993 * sp[32] + -0.8660254037844755 * sp[27] + 3.464101615137741 * sp[30];
    A[200] = 3.897114317029979 * sp[33] + -1.299038105676648 * sp[34] + 9.093266739736659 * sp[28] + -1.299038105676625 * sp[31] + 0.8660254037844379 * sp[34] + -0.2165063509460623 * sp[35] + 0.6495190528383281 * sp[29] + -0.4330127018921566 * sp[32] + 0.8660254037844323 * sp[28] + -2.814582562299337 * sp[29] + 8.443747686898277 * sp[26] + -2.165063509461034 * sp[27] + -1.732050807568868 * sp[31] + -1.732050807568821 * sp[32] + -1.732050807568861 * sp[27] + -3.897114317029963 * sp[30];
    A[201] = 10.39230484541331 * sp[33] + 11.69134295108997 * sp[34] + 11.69134295109 * sp[28] + 11.69134295108997 * sp[31] + 7.361215932167808 * sp[34] + 6.062177826491085 * sp[35] + 12.9903810567667 * sp[29] + 11.69134295108998 * sp[32] + 7.361215932167607 * sp[28] + 12.99038105676646 * sp[29] + -7.794228634059967 * sp[26] + -3.897114317029985 * sp[27] + -6.495190528383215 * sp[31] + -8.227241335952131 * sp[32] + -6.495190528383206 * sp[27] + -6.06217782649099 * sp[30];
    A[202] = -20.78460969082661 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541332 * sp[28] + -10.39230484541325 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137792 * sp[35] + -17.32050807568895 * sp[29] + -10.39230484541331 * sp[32] + -10.39230484541307 * sp[28] + -17.32050807568868 * sp[29] + 24.24871130596444 * sp[26] + 3.464101615137805 * sp[27] + 17.32050807568864 * sp[31] + 3.46410161513765 * sp[32] + 17.32050807568864 * sp[27] + 7.794228634059789 * sp[30];
    A[203] = 10.39230484541332 * sp[33] + -1.299038105676695 * sp[34] + -1.299038105676687 * sp[28] + -1.299038105676727 * sp[31] + 3.031088913245595 * sp[34] + -2.598076211353359 * sp[35] + 4.330127018922266 * sp[29] + -1.299038105676734 * sp[32] + 3.031088913245462 * sp[28] + 4.33012701892233 * sp[29] + -16.45448267190447 * sp[26] + 0.4330127018923423 * sp[27] + -10.82531754730543 * sp[31] + 4.763139720814379 * sp[32] + -10.82531754730546 * sp[27] + 2.598076211353328 * sp[30];
    A[204] = -36.74234614174804 * sp[33] + -36.74234614174792 * sp[34] + 36.74234614174794 * sp[28] + 36.74234614174783 * sp[31] + -24.49489742783207 * sp[34] + -30.6186217847898 * sp[35] + 42.86607049870598 * sp[29] + 36.74234614174809 * sp[32] + -24.49489742783202 * sp[28] + -6.123724356958409 * sp[29] + -30.61862178478984 * sp[26] + -12.24744871391659 * sp[27] + -24.49489742783143 * sp[27] + -36.74234614174713 * sp[30];
    A[205] = -67.50000000000063 * sp[33] + 90.00000000000063 * sp[28] + 90.00000000000045 * sp[31] + 7.500000000000099 * sp[34] + 3.750000000000028 * sp[35] + 93.75000000000078 * sp[29] + 90.00000000000078 * sp[32] + 7.499999999998792 * sp[28] + 48.74999999999876 * sp[29] + -41.25000000000006 * sp[26] + -30.00000000000092 * sp[27] + 52.50000000000028 * sp[31] + -22.49999999999964 * sp[32] + -37.49999999999935 * sp[27] + -67.49999999999909 * sp[30];
    A[206] = 12.99038105676665 * sp[33] + -25.98076211353322 * sp[34] + 25.9807621135334 * sp[28] + 25.98076211353341 * sp[31] + -4.330127018922268 * sp[34] + 10.82531754730567 * sp[35] + 10.82531754730554 * sp[29] + 25.98076211353309 * sp[32] + -4.330127018922251 * sp[28] + 2.165063509460655 * sp[29] + 36.80607966083918 * sp[26] + -8.660254037843547 * sp[27] + -12.99038105676665 * sp[31] + 12.99038105676659 * sp[32] + 21.65063509461097 * sp[27] + 12.9903810567662 * sp[30];
    A[207] = 36.7423461417478 * sp[34] + -110.2270384252438 * sp[28] + -36.7423461417481 * sp[31] + 12.24744871391604 * sp[34] + 24.49489742783175 * sp[35] + -48.98979485566409 * sp[29] + -36.74234614174834 * sp[32] + 12.24744871391604 * sp[28] + 24.49489742783193 * sp[29] + -48.98979485566366 * sp[26] + 12.24744871391601 * sp[27] + 12.24744871391601 * sp[31] + 12.24744871391586 * sp[32] + 36.74234614174728 * sp[27] + 24.4948974278314 * sp[30];
    A[208] = 135.0000000000011 * sp[33] + 67.50000000000063 * sp[34] + 67.5000000000004 * sp[28] + -22.49999999999964 * sp[31] + 67.50000000000063 * sp[34] + 67.50000000000082 * sp[35] + -22.50000000000005 * sp[29] + -22.49999999999961 * sp[32] + 67.5000000000004 * sp[28] + -22.50000000000005 * sp[29] + 247.4999999999999 * sp[26] + 67.50000000000016 * sp[27] + -22.49999999999964 * sp[31] + -22.49999999999961 * sp[32] + 67.50000000000016 * sp[27] + 59.99999999999966 * sp[30];
    A[209] = 64.95190528383313 * sp[34] + -38.97114317030021 * sp[28] + 12.99038105676635 * sp[31] + 21.65063509461124 * sp[34] + 43.3012701892219 * sp[35] + -8.660254037844371 * sp[29] + 12.99038105676662 * sp[32] + 21.65063509461125 * sp[28] + 43.30127018922215 * sp[29] + -8.660254037845018 * sp[26] + 99.59292143520935 * sp[27] + 21.65063509461117 * sp[31] + 21.65063509461089 * sp[32] + -12.99038105676647 * sp[27] + 43.30127018922249 * sp[30];
    A[210] = 10.41666666666659 * sp[33] + -5.833333333333353 * sp[34] + 0.8333333333333343 * sp[28] + 0.8333333333334098 * sp[31] + -2.916666666666717 * sp[34] + -4.375000000000025 * sp[35] + -3.541666666666728 * sp[29] + 0.8333333333333366 * sp[32] + 10.08333333333335 * sp[28] + -2.874999999999989 * sp[29] + 7.95833333333342 * sp[26] + 1.833333333333372 * sp[27] + -1.416666666666657 * sp[31] + -1.416666666666779 * sp[32] + 3.583333333333328 * sp[27] + 2.916666666666633 * sp[30];
    A[211] = -20.83333333333331 * sp[33] + 15.83333333333336 * sp[34] + -5.833333333333348 * sp[28] + -5.833333333333488 * sp[31] + -6.666666666666674 * sp[34] + 4.583333333333421 * sp[35] + 2.916666666666683 * sp[29] + -5.833333333333419 * sp[32] + -12.66666666666665 * sp[28] + 11.58333333333332 * sp[29] + -10.08333333333342 * sp[26] + 2.166666666666585 * sp[27] + 0.3333333333333592 * sp[31] + 0.3333333333335893 * sp[32] + -1.33333333333337 * sp[27] + 13.33333333333324 * sp[30];
    A[212] = -10.41666666666674 * sp[33] + -30.83333333333341 * sp[34] + 9.166666666666739 * sp[28] + 9.166666666666769 * sp[31] + -7.083333333333384 * sp[34] + -18.95833333333344 * sp[35] + 6.875000000000029 * sp[29] + 9.166666666666735 * sp[32] + -4.083333333333331 * sp[28] + -12.4583333333333 * sp[29] + 3.375000000000033 * sp[26] + 0.1666666666666958 * sp[27] + -0.5833333333333091 * sp[31] + -0.583333333333431 * sp[32] + 1.083333333333323 * sp[27] + -12.91666666666669 * sp[30];
    A[213] = 10.41666666666678 * sp[33] + 16.25000000000007 * sp[34] + 9.583333333333403 * sp[28] + 16.25000000000002 * sp[31] + 13.33333333333342 * sp[34] + 14.7916666666667 * sp[35] + 8.958333333333469 * sp[29] + 10.41666666666672 * sp[32] + 0.3333333333333051 * sp[28] + 3.291666666666651 * sp[29] + 7.458333333333223 * sp[26] + 9.416666666666604 * sp[27] + 1.833333333333292 * sp[31] + 1.833333333333339 * sp[32] + 1.833333333333262 * sp[27] + 2.916666666666619 * sp[30];
    A[214] = -20.83333333333344 * sp[33] + -36.66666666666677 * sp[34] + -14.99999999999999 * sp[28] + -36.66666666666671 * sp[31] + -14.16666666666675 * sp[34] + -25.41666666666677 * sp[35] + -5.416666666666699 * sp[29] + -16.6666666666668 * sp[32] + -8.166666666666654 * sp[28] + -12.41666666666663 * sp[29] + -12.41666666666659 * sp[26] + -24.6666666666666 * sp[27] + -1.166666666666623 * sp[31] + -1.166666666666715 * sp[32] + -1.166666666666584 * sp[27] + 10.00000000000006 * sp[30];
    A[215] = -10.41666666666664 * sp[33] + 20.41666666666669 * sp[34] + -19.58333333333336 * sp[28] + 20.41666666666674 * sp[31] + -3.333333333333341 * sp[34] + 8.541666666666753 * sp[35] + -5.624999999999998 * sp[29] + 6.25000000000017 * sp[32] + -6.333333333333312 * sp[28] + 12.04166666666664 * sp[29] + -12.12500000000005 * sp[26] + 15.24999999999998 * sp[27] + 0.166666666666676 * sp[31] + 0.1666666666668761 * sp[32] + 0.1666666666666656 * sp[27] + -12.91666666666645 * sp[30];
    A[216] = 4.166666666666629 * sp[33] + 7.083333333333313 * sp[34] + 7.083333333333408 * sp[28] + 7.083333333333388 * sp[31] + 0.4166666666666368 * sp[34] + -0.4166666666666101 * sp[35] + 7.916666666666662 * sp[29] + 7.083333333333349 * sp[32] + 8.416666666666629 * sp[28] + 13.58333333333326 * sp[29] + 1.916666666666703 * sp[26] + 3.083333333333331 * sp[27] + 2.749999999999916 * sp[31] + -8.91666666666692 * sp[32] + 2.749999999999953 * sp[27] + -3.333333333333458 * sp[30];
    A[217] = -1.66666666666673 * sp[34] + -1.666666666666686 * sp[28] + -1.666666666666729 * sp[31] + 3.333333333333304 * sp[34] + 0.8333333333333073 * sp[35] + 0.833333333333409 * sp[29] + -1.666666666666649 * sp[32] + -12.66666666666664 * sp[28] + -7.166666666666652 * sp[29] + -7.166666666666755 * sp[26] + -3.666666666666684 * sp[27] + -4.666666666666607 * sp[31] + -7.999999999999865 * sp[32] + -4.666666666666631 * sp[27] + -5.833333333333224 * sp[30];
    A[218] = -4.166666666666693 * sp[33] + 2.916666666666885 * sp[34] + 2.91666666666666 * sp[28] + 2.916666666666785 * sp[31] + -3.749999999999966 * sp[34] + 3.750000000000129 * sp[35] + -4.583333333333377 * sp[29] + 2.916666666666719 * sp[32] + 4.249999999999979 * sp[28] + -2.249999999999899 * sp[29] + 9.416666666666758 * sp[26] + -1.083333333333268 * sp[27] + 1.916666666666696 * sp[31] + -13.08333333333323 * sp[32] + 1.916666666666689 * sp[27] + -6.666666666666608 * sp[30];
    A[219] = -58.92556509887928 * sp[33] + -82.4957911384312 * sp[34] + -11.78511301977577 * sp[28] + -11.78511301977603 * sp[31] + -47.14045207910346 * sp[34] + -64.81812160876746 * sp[35] + 5.892556509887761 * sp[29] + -11.78511301977606 * sp[32] + -18.85618083164115 * sp[28] + -22.39171473757409 * sp[29] + -8.249579113843081 * sp[26] + 16.49915822768592 * sp[27] + -4.714045207910223 * sp[31] + 80.13876853447553 * sp[32] + 9.428090415820426 * sp[27] + 54.21151989096802 * sp[30];
    A[220] = 50.51814855409177 * sp[33] + 14.43375672973967 * sp[34] + 14.43375672974099 * sp[28] + 14.43375672974047 * sp[31] + -7.216878364871526 * sp[34] + -39.6928310067873 * sp[35] + 46.90970937165695 * sp[29] + 14.43375672974036 * sp[32] + 44.74464586219604 * sp[28] + 72.89047148518964 * sp[29] + -13.7120688932536 * sp[26] + 31.75426480542912 * sp[27] + 105.3664241271053 * sp[31] + 62.06515393788319 * sp[32] + 18.76388374866237 * sp[27] + 50.51814855409098 * sp[30];
    A[221] = -104.1666666666669 * sp[33] + -33.3333333333331 * sp[34] + 66.66666666666728 * sp[28] + 66.66666666666733 * sp[31] + -45.83333333333361 * sp[34] + -39.58333333333351 * sp[35] + 60.41666666666707 * sp[29] + 66.66666666666723 * sp[32] + -55.83333333333331 * sp[28] + 5.416666666666925 * sp[29] + 5.416666666666713 * sp[26] + -3.333333333333183 * sp[27] + -0.8333333333331903 * sp[31] + -25.83333333333406 * sp[32] + -0.8333333333333997 * sp[27] + -104.1666666666668 * sp[30];
    A[222] = 117.8511301977583 * sp[33] + 58.92556509887934 * sp[34] + 58.92556509887859 * sp[28] + -11.78511301977608 * sp[31] + 58.92556509887928 * sp[34] + 58.9255650988791 * sp[35] + -11.78511301977607 * sp[29] + -11.78511301977596 * sp[32] + 58.92556509887891 * sp[28] + 2.357022603955152 * sp[29] + 44.78342947514815 * sp[26] + -11.78511301977583 * sp[27] + 2.357022603954984 * sp[31] + 2.357022603954547 * sp[32] + -11.78511301977572 * sp[27] + -9.428090415820879 * sp[30];
    A[223] = 21.65063509461124 * sp[34] + 21.65063509461125 * sp[28] + 21.65063509461117 * sp[31] + 64.95190528383313 * sp[34] + 43.3012701892219 * sp[35] + 43.30127018922215 * sp[29] + 21.65063509461089 * sp[32] + -38.97114317030021 * sp[28] + -8.660254037844371 * sp[29] + -8.660254037845018 * sp[26] + -12.99038105676647 * sp[27] + 12.99038105676635 * sp[31] + 12.99038105676662 * sp[32] + 99.59292143520935 * sp[27] + 43.30127018922249 * sp[30];
    A[224] = 208.3333333333338 * sp[33] + 104.1666666666672 * sp[34] + 104.1666666666665 * sp[28] + 4.166666666666357 * sp[31] + 104.1666666666672 * sp[34] + 104.1666666666668 * sp[35] + 4.166666666666631 * sp[29] + 4.166666666665577 * sp[32] + 104.1666666666665 * sp[28] + 4.166666666666631 * sp[29] + 104.1666666666667 * sp[26] + 4.166666666666526 * sp[27] + 4.166666666666357 * sp[31] + 4.166666666665577 * sp[32] + 4.166666666666526 * sp[27] + 183.3333333333314 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698429 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.05734126984127034 * sp[17];
    A[1] = -0.02986111111111115 * sp[19] + 0.005952380952380886 * sp[18] + 0.009920634920635005 * sp[18] + -0.0487103174603178 * sp[17];
    A[2] = 0.01765873015873007 * sp[19] + -0.004712301587301548 * sp[18] + -0.004712301587301595 * sp[18] + 0.01765873015873015 * sp[17];
    A[3] = -0.0154265873015874 * sp[19] + -0.02447916666666679 * sp[18] + 0.009052579365079392 * sp[18] + 0.0186011904761906 * sp[17];
    A[4] = 0.01746031746031737 * sp[19] + 0.02167658730158714 * sp[18] + -0.005704365079365079 * sp[18] + -0.01190476190476188 * sp[17];
    A[5] = -0.02385912698412693 * sp[19] + -0.03266369047619049 * sp[18] + 0.006820436507936537 * sp[18] + 0.01116071428571416 * sp[17];
    A[6] = -0.01314484126984129 * sp[19] + -0.008804563492063539 * sp[18] + 0.03067956349206365 * sp[18] + 0.0238591269841271 * sp[17];
    A[7] = 0.02777777777777803 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285777 * sp[18] + -0.06111111111111161 * sp[17];
    A[8] = -0.02058531746031762 * sp[19] + -0.007068452380952364 * sp[18] + 0.05820932539682571 * sp[18] + 0.05114087301587344 * sp[17];
    A[9] = 0.04349267900155092 * sp[19] + -0.02314932914598866 * sp[18] + -0.06243303921190616 * sp[18] + 0.03507474113028564 * sp[17];
    A[10] = 0.06529556615835222 * sp[19] + -0.05154913117764588 * sp[18] + -0.1271545235715236 * sp[18] + 0.06529556615835097 * sp[17];
    A[11] = -0.01686507936508135 * sp[19] + -0.007440476190475729 * sp[18] + 0.07192460317460246 * sp[18] + -0.01091269841269969 * sp[17];
    A[12] = 0.03507474113028562 * sp[19] + 0.1283735525368422 * sp[18] + -0.01192541198429721 * sp[18] + -0.1248660784238149 * sp[17];
    A[13] = -0.1005208057964094 * sp[19] + -0.0631476856926154 * sp[18] + 0.07088005536926234 * sp[18] + -0.08505606644311368 * sp[17];
    A[14] = 0.06200396825396912 * sp[19] + 0.09598214285714141 * sp[18] + -0.02108134920634968 * sp[18] + 0.05307539682539827 * sp[17];
    A[15] = -0.02986111111111115 * sp[19] + 0.009920634920635005 * sp[18] + 0.005952380952380886 * sp[18] + -0.0487103174603178 * sp[17];
    A[16] = 0.06865079365079398 * sp[19] + -0.01289682539682545 * sp[18] + -0.01289682539682545 * sp[18] + 0.06865079365079427 * sp[17];
    A[17] = -0.04871031746031761 * sp[19] + 0.005952380952380871 * sp[18] + 0.009920634920634953 * sp[18] + -0.0298611111111113 * sp[17];
    A[18] = 0.01746031746031738 * sp[19] + 0.0231646825396825 * sp[18] + -0.004216269841269753 * sp[18] + -0.01041666666666663 * sp[17];
    A[19] = -0.0438492063492064 * sp[19] + -0.05327380952380972 * sp[18] + 0.009424603174603176 * sp[18] + 0.01785714285714285 * sp[17];
    A[20] = 0.06111111111111135 * sp[19] + 0.0752480158730163 * sp[18] + -0.01165674603174608 * sp[18] + -0.0252976190476191 * sp[17];
    A[21] = 0.01041666666666671 * sp[19] + 0.004216269841269758 * sp[18] + -0.02316468253968258 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.01785714285714305 * sp[19] + -0.00942460317460323 * sp[18] + 0.0532738095238099 * sp[18] + 0.04384920634920658 * sp[17];
    A[23] = 0.02529761904761937 * sp[19] + 0.01165674603174613 * sp[18] + -0.07524801587301654 * sp[18] + -0.06111111111111169 * sp[17];
    A[24] = -0.0785674201318376 * sp[19] + -0.0098209275164798 * sp[18] + 0.1360899955855054 * sp[18] + 0.07014948226057123 * sp[17];
    A[25] = -0.05326743555023454 * sp[19] + -0.008591521862941364 * sp[18] + 0.1838585678669347 * sp[18] + 0.0841969142568223 * sp[17];
    A[26] = -0.004960317460314933 * sp[19] + 0.01984126984126909 * sp[18] + -0.162698412698412 * sp[18] + -0.1021825396825403 * sp[17];
    A[27] = -0.07014948226057113 * sp[19] + -0.1360899955855056 * sp[18] + 0.009820927516480045 * sp[18] + 0.07856742013183723 * sp[17];
    A[28] = 0.04639421805988011 * sp[19] + 0.04897167461876194 * sp[18] + -0.01288728279441044 * sp[18] + 0.03092947870658592 * sp[17];
    A[29] = -0.1240079365079381 * sp[19] + -0.2405753968253959 * sp[18] + 0.01736111111111151 * sp[18] + 0.04365079365079524 * sp[17];
    A[30] = 0.01765873015873007 * sp[19] + -0.004712301587301595 * sp[18] + -0.004712301587301548 * sp[18] + 0.01765873015873015 * sp[17];
    A[31] = -0.04871031746031761 * sp[19] + 0.009920634920634953 * sp[18] + 0.005952380952380871 * sp[18] + -0.0298611111111113 * sp[17];
    A[32] = 0.05734126984127023 * sp[19] + -0.01116071428571431 * sp[18] + -0.01116071428571431 * sp[18] + 0.02162698412698434 * sp[17];
    A[33] = -0.02385912698412705 * sp[19] + -0.03067956349206366 * sp[18] + 0.008804563492063532 * sp[18] + 0.01314484126984129 * sp[17];
    A[34] = 0.06111111111111154 * sp[19] + 0.07276785714285777 * sp[18] + -0.01413690476190483 * sp[18] + -0.02777777777777797 * sp[17];
    A[35] = -0.05114087301587324 * sp[19] + -0.05820932539682569 * sp[18] + 0.007068452380952318 * sp[18] + 0.02058531746031752 * sp[17];
    A[36] = -0.01860119047619067 * sp[19] + -0.009052579365079375 * sp[18] + 0.02447916666666685 * sp[18] + 0.01542658730158742 * sp[17];
    A[37] = 0.01190476190476202 * sp[19] + 0.005704365079365079 * sp[18] + -0.0216765873015873 * sp[18] + -0.01746031746031745 * sp[17];
    A[38] = -0.01116071428571437 * sp[19] + -0.006820436507936533 * sp[18] + 0.03266369047619067 * sp[18] + 0.0238591269841271 * sp[17];
    A[39] = 0.124866078423815 * sp[19] + 0.01192541198429698 * sp[18] + -0.1283735525368424 * sp[18] + -0.03507474113028563 * sp[17];
    A[40] = -0.003436608745177442 * sp[19] + -0.01718304372588164 * sp[18] + -0.0515491311776442 * sp[18] + -0.003436608745176504 * sp[17];
    A[41] = 0.1001984126984123 * sp[19] + -0.07192460317460347 * sp[18] + 0.1026785714285714 * sp[18] + 0.1180555555555572 * sp[17];
    A[42] = -0.03507474113028584 * sp[19] + 0.06243303921190618 * sp[18] + 0.02314932914598855 * sp[18] + -0.0434926790015511 * sp[17];
    A[43] = -0.02319710902993947 * sp[19] + 0.001288728279441212 * sp[18] + 0.03221820698602824 * sp[18] + -0.01804219591217484 * sp[17];
    A[44] = -0.06200396825396948 * sp[19] + 0.1460813492063476 * sp[18] + 0.04092261904761972 * sp[18] + -0.06498015873016062 * sp[17];
    A[45] = -0.0154265873015874 * sp[19] + 0.009052579365079392 * sp[18] + -0.02447916666666679 * sp[18] + 0.0186011904761906 * sp[17];
    A[46] = 0.01746031746031738 * sp[19] + -0.004216269841269753 * sp[18] + 0.0231646825396825 * sp[18] + -0.01041666666666663 * sp[17];
    A[47] = -0.02385912698412705 * sp[19] + 0.008804563492063532 * sp[18] + -0.03067956349206366 * sp[18] + 0.01314484126984129 * sp[17];
    A[48] = 0.02162698412698435 * sp[19] + 0.03278769841269869 * sp[18] + 0.03278769841269869 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.02986111111111127 * sp[19] + -0.03581349206349219 * sp[18] + -0.03978174603174634 * sp[18] + -0.09444444444444482 * sp[17];
    A[50] = 0.01765873015873009 * sp[19] + 0.02237103174603166 * sp[18] + 0.02237103174603171 * sp[18] + 0.04474206349206335 * sp[17];
    A[51] = 0.0205853174603176 * sp[19] + 0.0135168650793652 * sp[18] + 0.07879464285714323 * sp[18] + 0.0205853174603176 * sp[17];
    A[52] = -0.027777777777778 * sp[19] + -0.0136408730158731 * sp[18] + -0.1005456349206355 * sp[18] + -0.02529761904761924 * sp[17];
    A[53] = 0.01314484126984129 * sp[19] + 0.004340277777777709 * sp[18] + 0.04382440476190484 * sp[18] + 0.0111607142857143 * sp[17];
    A[54] = -0.07856742013183664 * sp[19] + 0.02665680325901717 * sp[18] + -0.1529258713280409 * sp[18] + 0.04208968935634277 * sp[17];
    A[55] = -0.03522523963805749 * sp[19] + 0.07947157723220406 * sp[18] + 0.02104922856420386 * sp[18] + 0.1159855451497027 * sp[17];
    A[56] = -0.0451388888888881 * sp[19] + 0.04340277777777805 * sp[18] + 0.005704365079364733 * sp[18] + 0.05208333333333326 * sp[17];
    A[57] = 0.03507474113028568 * sp[19] + -0.09329881140655666 * sp[18] + 0.04700015311458289 * sp[18] + -0.2062394778460747 * sp[17];
    A[58] = 0.1005208057964094 * sp[19] + 0.0373731201037938 * sp[18] + 0.1714008611656715 * sp[18] + 0.1933092419161693 * sp[17];
    A[59] = 0.0620039682539693 * sp[19] + -0.03397817460317251 * sp[18] + 0.08308531746031901 * sp[18] + 0.04017857142857447 * sp[17];
    A[60] = 0.01746031746031737 * sp[19] + -0.005704365079365079 * sp[18] + 0.02167658730158714 * sp[18] + -0.01190476190476188 * sp[17];
    A[61] = -0.0438492063492064 * sp[19] + 0.009424603174603176 * sp[18] + -0.05327380952380972 * sp[18] + 0.01785714285714285 * sp[17];
    A[62] = 0.06111111111111154 * sp[19] + -0.01413690476190483 * sp[18] + 0.07276785714285777 * sp[18] + -0.02777777777777797 * sp[17];
    A[63] = -0.02986111111111127 * sp[19] + -0.03978174603174634 * sp[18] + -0.03581349206349219 * sp[18] + -0.09444444444444482 * sp[17];
    A[64] = 0.06865079365079418 * sp[19] + 0.08154761904761977 * sp[18] + 0.08154761904761977 * sp[18] + 0.1630952380952395 * sp[17];
    A[65] = -0.04871031746031763 * sp[19] + -0.05466269841269862 * sp[18] + -0.05863095238095271 * sp[18] + -0.09444444444444494 * sp[17];
    A[66] = -0.02529761904761932 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206357 * sp[18] + -0.02777777777777796 * sp[17];
    A[67] = 0.01785714285714302 * sp[19] + 0.008432539682539698 * sp[18] + 0.07113095238095253 * sp[18] + 0.01785714285714287 * sp[17];
    A[68] = -0.01041666666666669 * sp[19] + -0.006200396825396815 * sp[18] + -0.03358134920634915 * sp[18] + -0.01190476190476186 * sp[17];
    A[69] = 0.1487169023924086 * sp[19] + 0.00280597929042274 * sp[18] + 0.2946278254943952 * sp[18];
    A[70] = -0.006873217490354525 * sp[19] + -0.04725337024617509 * sp[18] + -0.1778445025628793 * sp[18] + -0.1030982623552912 * sp[17];
    A[71] = 0.1289682539682536 * sp[19] + -0.09176587301587365 * sp[18] + -0.01636904761904667 * sp[18] + -0.1785714285714303 * sp[17];
    A[72] = -0.07014948226057147 * sp[19] + 0.06594051332493409 * sp[18] + -0.07997040977705144 * sp[18] + 0.134687005940292 * sp[17];
    A[73] = -0.04639421805988015 * sp[19] + 0.002577456558881577 * sp[18] + -0.05928150085429042 * sp[18] + -0.04123930494211474 * sp[17];
    A[74] = -0.1240079365079387 * sp[19] + 0.1165674603174578 * sp[18] + -0.14136904761905 * sp[18] + 0.1428571428571432 * sp[17];
    A[75] = -0.02385912698412693 * sp[19] + 0.006820436507936537 * sp[18] + -0.03266369047619049 * sp[18] + 0.01116071428571416 * sp[17];
    A[76] = 0.06111111111111135 * sp[19] + -0.01165674603174608 * sp[18] + 0.0752480158730163 * sp[18] + -0.0252976190476191 * sp[17];
    A[77] = -0.05114087301587324 * sp[19] + 0.007068452380952318 * sp[18] + -0.05820932539682569 * sp[18] + 0.02058531746031752 * sp[17];
    A[78] = 0.01765873015873009 * sp[19] + 0.02237103174603171 * sp[18] + 0.02237103174603166 * sp[18] + 0.04474206349206335 * sp[17];
    A[79] = -0.04871031746031763 * sp[19] + -0.05863095238095271 * sp[18] + -0.05466269841269862 * sp[18] + -0.09444444444444494 * sp[17];
    A[80] = 0.05734126984127008 * sp[19] + 0.06850198412698451 * sp[18] + 0.06850198412698451 * sp[18] + 0.1012896825396833 * sp[17];
    A[81] = 0.01116071428571434 * sp[19] + 0.004340277777777687 * sp[18] + 0.0438244047619049 * sp[18] + 0.01314484126984122 * sp[17];
    A[82] = -0.01190476190476199 * sp[19] + -0.006200396825396819 * sp[18] + -0.03358134920634904 * sp[18] + -0.01041666666666648 * sp[17];
    A[83] = 0.01860119047619067 * sp[19] + 0.009548611111111176 * sp[18] + 0.04308035714285743 * sp[18] + 0.01860119047619048 * sp[17];
    A[84] = -0.08979133729352902 * sp[19] + -0.01543288609732555 * sp[18] + -0.1950155606843833 * sp[18] + -0.0420896893563427 * sp[17];
    A[85] = -0.02663371777511692 * sp[19] + -0.01073940232867669 * sp[18] + -0.007302793583500597 * sp[18] + -0.01288728279441215 * sp[17];
    A[86] = -0.03819444444444282 * sp[19] + 0.03596230158730111 * sp[18] + 0.1054067460317483 * sp[18] + 0.1264880952380962 * sp[17];
    A[87] = -0.03507474113028547 * sp[19] + -0.09750778034219135 * sp[18] + -0.05822407027627415 * sp[18] + -0.1641497884897312 * sp[17];
    A[88] = 0.02319710902993928 * sp[19] + 0.02448583730938062 * sp[18] + 0.05541531601596746 * sp[18] + 0.07474624020758391 * sp[17];
    A[89] = -0.06200396825396894 * sp[19] + -0.2080853174603164 * sp[18] + -0.1029265873015889 * sp[18] + -0.3139880952380976 * sp[17];
    A[90] = -0.01314484126984129 * sp[19] + 0.03067956349206365 * sp[18] + -0.008804563492063539 * sp[18] + 0.0238591269841271 * sp[17];
    A[91] = 0.01041666666666671 * sp[19] + -0.02316468253968258 * sp[18] + 0.004216269841269758 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619067 * sp[19] + 0.02447916666666685 * sp[18] + -0.009052579365079375 * sp[18] + 0.01542658730158742 * sp[17];
    A[93] = 0.0205853174603176 * sp[19] + 0.07879464285714323 * sp[18] + 0.0135168650793652 * sp[18] + 0.0205853174603176 * sp[17];
    A[94] = -0.02529761904761932 * sp[19] + -0.1005456349206357 * sp[18] + -0.01364087301587309 * sp[18] + -0.02777777777777796 * sp[17];
    A[95] = 0.01116071428571434 * sp[19] + 0.0438244047619049 * sp[18] + 0.004340277777777687 * sp[18] + 0.01314484126984122 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269871 * sp[18] + 0.03278769841269871 * sp[18] + 0.02162698412698434 * sp[17];
    A[97] = -0.09444444444444482 * sp[19] + -0.03978174603174629 * sp[18] + -0.03581349206349223 * sp[18] + -0.02986111111111129 * sp[17];
    A[98] = 0.04474206349206348 * sp[19] + 0.02237103174603179 * sp[18] + 0.02237103174603173 * sp[18] + 0.01765873015873018 * sp[17];
    A[99] = -0.2062394778460754 * sp[19] + 0.04700015311458267 * sp[18] + -0.09329881140655687 * sp[18] + 0.0350747411302856 * sp[17];
    A[100] = 0.1314502845029978 * sp[19] + 0.1576544261849666 * sp[18] + -0.01073940232867417 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714275 * sp[19] + 0.1068948412698424 * sp[18] + 0.04935515873015888 * sp[18] + 0.05605158730158797 * sp[17];
    A[102] = 0.04208968935634275 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901707 * sp[18] + -0.07856742013183683 * sp[17];
    A[103] = 0.1030982623552905 * sp[19] + 0.01546473935329259 * sp[18] + 0.07732369676646851 * sp[18] + -0.05670404429540901 * sp[17];
    A[104] = 0.07440476190476308 * sp[19] + 0.01537698412698293 * sp[18] + 0.0471230158730166 * sp[18] + -0.007936507936507858 * sp[17];
    A[105] = 0.02777777777777803 * sp[19] + -0.07276785714285777 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111161 * sp[17];
    A[106] = -0.01785714285714305 * sp[19] + 0.0532738095238099 * sp[18] + -0.00942460317460323 * sp[18] + 0.04384920634920658 * sp[17];
    A[107] = 0.01190476190476202 * sp[19] + -0.0216765873015873 * sp[18] + 0.005704365079365079 * sp[18] + -0.01746031746031745 * sp[17];
    A[108] = -0.027777777777778 * sp[19] + -0.1005456349206355 * sp[18] + -0.0136408730158731 * sp[18] + -0.02529761904761924 * sp[17];
    A[109] = 0.01785714285714302 * sp[19] + 0.07113095238095253 * sp[18] + 0.008432539682539698 * sp[18] + 0.01785714285714287 * sp[17];
    A[110] = -0.01190476190476199 * sp[19] + -0.03358134920634904 * sp[18] + -0.006200396825396819 * sp[18] + -0.01041666666666648 * sp[17];
    A[111] = -0.09444444444444482 * sp[19] + -0.03581349206349223 * sp[18] + -0.03978174603174629 * sp[18] + -0.02986111111111129 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761973 * sp[18] + 0.08154761904761973 * sp[18] + 0.06865079365079423 * sp[17];
    A[113] = -0.09444444444444494 * sp[19] + -0.05863095238095289 * sp[18] + -0.05466269841269863 * sp[18] + -0.04871031746031781 * sp[17];
    A[114] = 0.1346870059402924 * sp[19] + -0.07997040977705092 * sp[18] + 0.06594051332493431 * sp[18] + -0.07014948226057117 * sp[17];
    A[115] = 0.1030982623552917 * sp[19] + -0.1520699369740541 * sp[18] + 0.1022391101689944 * sp[18] + -0.1305911323167023 * sp[17];
    A[116] = -0.1071428571428564 * sp[19] + 0.01934523809523977 * sp[18] + -0.05605158730158687 * sp[18] + 0.02182539682539822 * sp[17];
    A[117] = 0.2946278254943949 * sp[18] + 0.002805979290422962 * sp[18] + 0.1487169023924086 * sp[17];
    A[118] = -0.2061965247105821 * sp[19] + -0.1030982623552906 * sp[18] + -0.103098262355291 * sp[18] + 0.108253175473054 * sp[17];
    A[119] = -0.1458333333333367 * sp[18] + 0.004960317460317706 * sp[18] + -0.07043650793651011 * sp[17];
    A[120] = -0.02058531746031762 * sp[19] + 0.05820932539682571 * sp[18] + -0.007068452380952364 * sp[18] + 0.05114087301587344 * sp[17];
    A[121] = 0.02529761904761937 * sp[19] + -0.07524801587301654 * sp[18] + 0.01165674603174613 * sp[18] + -0.06111111111111169 * sp[17];
    A[122] = -0.01116071428571437 * sp[19] + 0.03266369047619067 * sp[18] + -0.006820436507936533 * sp[18] + 0.0238591269841271 * sp[17];
    A[123] = 0.01314484126984129 * sp[19] + 0.04382440476190484 * sp[18] + 0.004340277777777709 * sp[18] + 0.0111607142857143 * sp[17];
    A[124] = -0.01041666666666669 * sp[19] + -0.03358134920634915 * sp[18] + -0.006200396825396815 * sp[18] + -0.01190476190476186 * sp[17];
    A[125] = 0.01860119047619067 * sp[19] + 0.04308035714285743 * sp[18] + 0.009548611111111176 * sp[18] + 0.01860119047619048 * sp[17];
    A[126] = 0.04474206349206348 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603179 * sp[18] + 0.01765873015873018 * sp[17];
    A[127] = -0.09444444444444494 * sp[19] + -0.05466269841269863 * sp[18] + -0.05863095238095289 * sp[18] + -0.04871031746031781 * sp[17];
    A[128] = 0.1012896825396834 * sp[19] + 0.06850198412698473 * sp[18] + 0.06850198412698473 * sp[18] + 0.05734126984127042 * sp[17];
    A[129] = -0.1641497884897324 * sp[19] + -0.05822407027627449 * sp[18] + -0.09750778034219207 * sp[18] + -0.03507474113028568 * sp[17];
    A[130] = -0.2345485468582882 * sp[19] + -0.06142938132002929 * sp[18] + -0.1679642524204943 * sp[18] + -0.04209845712841154 * sp[17];
    A[131] = 0.221726190476191 * sp[19] + 0.09945436507936581 * sp[18] + 0.1252480158730152 * sp[18] + 0.05109126984126963 * sp[17];
    A[132] = -0.04208968935634308 * sp[19] + -0.1950155606843837 * sp[18] + -0.0154328860973258 * sp[18] + -0.08979133729352953 * sp[17];
    A[133] = 0.1030982623552905 * sp[19] + 0.08763352300199825 * sp[18] + 0.025774565588822 * sp[18] + -0.04639421805987989 * sp[17];
    A[134] = -0.07440476190476356 * sp[19] + -0.05902777777777999 * sp[18] + -0.02728174603174667 * sp[18] + -0.003968253968254367 * sp[17];
    A[135] = 0.04349267900155092 * sp[19] + -0.06243303921190616 * sp[18] + -0.02314932914598866 * sp[18] + 0.03507474113028564 * sp[17];
    A[136] = -0.0785674201318376 * sp[19] + 0.1360899955855054 * sp[18] + -0.0098209275164798 * sp[18] + 0.07014948226057123 * sp[17];
    A[137] = 0.124866078423815 * sp[19] + -0.1283735525368424 * sp[18] + 0.01192541198429698 * sp[18] + -0.03507474113028563 * sp[17];
    A[138] = -0.07856742013183664 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901717 * sp[18] + 0.04208968935634277 * sp[17];
    A[139] = 0.1487169023924086 * sp[19] + 0.2946278254943952 * sp[18] + 0.00280597929042274 * sp[18];
    A[140] = -0.08979133729352902 * sp[19] + -0.1950155606843833 * sp[18] + -0.01543288609732555 * sp[18] + -0.0420896893563427 * sp[17];
    A[141] = -0.2062394778460754 * sp[19] + -0.09329881140655687 * sp[18] + 0.04700015311458267 * sp[18] + 0.0350747411302856 * sp[17];
    A[142] = 0.1346870059402924 * sp[19] + 0.06594051332493431 * sp[18] + -0.07997040977705092 * sp[18] + -0.07014948226057117 * sp[17];
    A[143] = -0.1641497884897324 * sp[19] + -0.09750778034219207 * sp[18] + -0.05822407027627449 * sp[18] + -0.03507474113028568 * sp[17];
    A[144] = 4.920634920634908 * sp[19] + 0.198412698412702 * sp[18] + 0.198412698412702 * sp[18] + 0.3968253968254025 * sp[17];
    A[145] = 0.02430049347996843 * sp[19] + -0.06075123369997135 * sp[18] + 0.2308546880599297 * sp[18] + 0.6075123369998048 * sp[17];
    A[146] = -0.5191061687282039 * sp[19] + -0.806719045996553 * sp[18] + -0.3016427737204518 * sp[18] + -0.3507474113028564 * sp[17];
    A[147] = -0.1984126984127016 * sp[19] + 4.305555555555533 * sp[18] + 0.01984126984126999 * sp[18] + -0.1984126984127006 * sp[17];
    A[148] = -0.2187044413199079 * sp[19] + -0.0364507402199899 * sp[18] + 0.2551551815399186 * sp[18] + -0.2187044413199265 * sp[17];
    A[149] = -0.3507474113028569 * sp[19] + 0.540151013406388 * sp[18] + 0.03507474113028547 * sp[18] + 0.3226876183986322 * sp[17];
    A[150] = 0.06529556615835222 * sp[19] + -0.1271545235715236 * sp[18] + -0.05154913117764588 * sp[18] + 0.06529556615835097 * sp[17];
    A[151] = -0.05326743555023454 * sp[19] + 0.1838585678669347 * sp[18] + -0.008591521862941364 * sp[18] + 0.0841969142568223 * sp[17];
    A[152] = -0.003436608745177442 * sp[19] + -0.0515491311776442 * sp[18] + -0.01718304372588164 * sp[18] + -0.003436608745176504 * sp[17];
    A[153] = -0.03522523963805749 * sp[19] + 0.02104922856420386 * sp[18] + 0.07947157723220406 * sp[18] + 0.1159855451497027 * sp[17];
    A[154] = -0.006873217490354525 * sp[19] + -0.1778445025628793 * sp[18] + -0.04725337024617509 * sp[18] + -0.1030982623552912 * sp[17];
    A[155] = -0.02663371777511692 * sp[19] + -0.007302793583500597 * sp[18] + -0.01073940232867669 * sp[18] + -0.01288728279441215 * sp[17];
    A[156] = 0.1314502845029978 * sp[19] + -0.01073940232867417 * sp[18] + 0.1576544261849666 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552917 * sp[19] + 0.1022391101689944 * sp[18] + -0.1520699369740541 * sp[18] + -0.1305911323167023 * sp[17];
    A[158] = -0.2345485468582882 * sp[19] + -0.1679642524204943 * sp[18] + -0.06142938132002929 * sp[18] + -0.04209845712841154 * sp[17];
    A[159] = 0.02430049347996843 * sp[19] + 0.2308546880599297 * sp[18] + -0.06075123369997135 * sp[18] + 0.6075123369998048 * sp[17];
    A[160] = 5.416666666666707 * sp[19] + 0.4315476190476332 * sp[18] + 0.4315476190476332 * sp[18] + 1.130952380952397 * sp[17];
    A[161] = -0.1890134809847084 * sp[19] + -0.06873217490352229 * sp[18] + -0.274928699614105 * sp[18] + -0.1890134809847011 * sp[17];
    A[162] = 0.1701034543599528 * sp[19] + 0.4495591293798422 * sp[18] + 0.1579532076199494 * sp[18] + -0.4131083891598574 * sp[17];
    A[163] = -0.4017857142857213 * sp[19] + 3.593749999999993 * sp[18] + 0.5580357142857226 * sp[18] + -0.4017857142857145 * sp[17];
    A[164] = 0.3007032652029474 * sp[19] + 0.1761261981902894 * sp[18] + 0.2792244605455824 * sp[18] + 0.3007032652029413 * sp[17];
    A[165] = -0.01686507936508135 * sp[19] + 0.07192460317460246 * sp[18] + -0.007440476190475729 * sp[18] + -0.01091269841269969 * sp[17];
    A[166] = -0.004960317460314933 * sp[19] + -0.162698412698412 * sp[18] + 0.01984126984126909 * sp[18] + -0.1021825396825403 * sp[17];
    A[167] = 0.1001984126984123 * sp[19] + 0.1026785714285714 * sp[18] + -0.07192460317460347 * sp[18] + 0.1180555555555572 * sp[17];
    A[168] = -0.0451388888888881 * sp[19] + 0.005704365079364733 * sp[18] + 0.04340277777777805 * sp[18] + 0.05208333333333326 * sp[17];
    A[169] = 0.1289682539682536 * sp[19] + -0.01636904761904667 * sp[18] + -0.09176587301587365 * sp[18] + -0.1785714285714303 * sp[17];
    A[170] = -0.03819444444444282 * sp[19] + 0.1054067460317483 * sp[18] + 0.03596230158730111 * sp[18] + 0.1264880952380962 * sp[17];
    A[171] = 0.1473214285714275 * sp[19] + 0.04935515873015888 * sp[18] + 0.1068948412698424 * sp[18] + 0.05605158730158797 * sp[17];
    A[172] = -0.1071428571428564 * sp[19] + -0.05605158730158687 * sp[18] + 0.01934523809523977 * sp[18] + 0.02182539682539822 * sp[17];
    A[173] = 0.221726190476191 * sp[19] + 0.1252480158730152 * sp[18] + 0.09945436507936581 * sp[18] + 0.05109126984126963 * sp[17];
    A[174] = -0.5191061687282039 * sp[19] + -0.3016427737204518 * sp[18] + -0.806719045996553 * sp[18] + -0.3507474113028564 * sp[17];
    A[175] = -0.1890134809847084 * sp[19] + -0.274928699614105 * sp[18] + -0.06873217490352229 * sp[18] + -0.1890134809847011 * sp[17];
    A[176] = 5.555555555555572 * sp[19] + 0.5902777777777791 * sp[18] + 0.5902777777777791 * sp[18] + 0.9126984126984292 * sp[17];
    A[177] = -0.3507474113028589 * sp[19] + -0.3016427737204461 * sp[18] + 0.2034334985556573 * sp[18] + -0.01402989645209592 * sp[17];
    A[178] = 0.07732369676647624 * sp[19] + 0.1675346763273487 * sp[18] + 0.06443641397205604 * sp[18] + 0.07732369676647269 * sp[17];
    A[179] = -0.6200396825396948 * sp[19] + 3.395337301587296 * sp[18] + 0.3596230158730225 * sp[18] + -0.6200396825397009 * sp[17];
    A[180] = 0.03507474113028562 * sp[19] + -0.01192541198429721 * sp[18] + 0.1283735525368422 * sp[18] + -0.1248660784238149 * sp[17];
    A[181] = -0.07014948226057113 * sp[19] + 0.009820927516480045 * sp[18] + -0.1360899955855056 * sp[18] + 0.07856742013183723 * sp[17];
    A[182] = -0.03507474113028584 * sp[19] + 0.02314932914598855 * sp[18] + 0.06243303921190618 * sp[18] + -0.0434926790015511 * sp[17];
    A[183] = 0.03507474113028568 * sp[19] + 0.04700015311458289 * sp[18] + -0.09329881140655666 * sp[18] + -0.2062394778460747 * sp[17];
    A[184] = -0.07014948226057147 * sp[19] + -0.07997040977705144 * sp[18] + 0.06594051332493409 * sp[18] + 0.134687005940292 * sp[17];
    A[185] = -0.03507474113028547 * sp[19] + -0.05822407027627415 * sp[18] + -0.09750778034219135 * sp[18] + -0.1641497884897312 * sp[17];
    A[186] = 0.04208968935634275 * sp[19] + 0.02665680325901707 * sp[18] + -0.1529258713280409 * sp[18] + -0.07856742013183683 * sp[17];
    A[187] = 0.002805979290422962 * sp[18] + 0.2946278254943949 * sp[18] + 0.1487169023924086 * sp[17];
    A[188] = -0.04208968935634308 * sp[19] + -0.0154328860973258 * sp[18] + -0.1950155606843837 * sp[18] + -0.08979133729352953 * sp[17];
    A[189] = -0.1984126984127016 * sp[19] + 0.01984126984126999 * sp[18] + 4.305555555555533 * sp[18] + -0.1984126984127006 * sp[17];
    A[190] = 0.1701034543599528 * sp[19] + 0.1579532076199494 * sp[18] + 0.4495591293798422 * sp[18] + -0.4131083891598574 * sp[17];
    A[191] = -0.3507474113028589 * sp[19] + 0.2034334985556573 * sp[18] + -0.3016427737204461 * sp[18] + -0.01402989645209592 * sp[17];
    A[192] = 0.3968253968254034 * sp[19] + 0.1984126984127013 * sp[18] + 0.1984126984127013 * sp[18] + 4.920634920634907 * sp[17];
    A[193] = -0.1458029608799464 * sp[18] + -0.7290148043997455 * sp[18] + -0.4374088826398529 * sp[17];
    A[194] = 0.7014948226057132 * sp[19] + 0.350747411302855 * sp[18] + 0.3507474113028555 * sp[18] + 0.2805979290422588 * sp[17];
    A[195] = -0.1005208057964094 * sp[19] + 0.07088005536926234 * sp[18] + -0.0631476856926154 * sp[18] + -0.08505606644311368 * sp[17];
    A[196] = 0.04639421805988011 * sp[19] + -0.01288728279441044 * sp[18] + 0.04897167461876194 * sp[18] + 0.03092947870658592 * sp[17];
    A[197] = -0.02319710902993947 * sp[19] + 0.03221820698602824 * sp[18] + 0.001288728279441212 * sp[18] + -0.01804219591217484 * sp[17];
    A[198] = 0.1005208057964094 * sp[19] + 0.1714008611656715 * sp[18] + 0.0373731201037938 * sp[18] + 0.1933092419161693 * sp[17];
    A[199] = -0.04639421805988015 * sp[19] + -0.05928150085429042 * sp[18] + 0.002577456558881577 * sp[18] + -0.04123930494211474 * sp[17];
    A[200] = 0.02319710902993928 * sp[19] + 0.05541531601596746 * sp[18] + 0.02448583730938062 * sp[18] + 0.07474624020758391 * sp[17];
    A[201] = 0.1030982623552905 * sp[19] + 0.07732369676646851 * sp[18] + 0.01546473935329259 * sp[18] + -0.05670404429540901 * sp[17];
    A[202] = -0.2061965247105821 * sp[19] + -0.103098262355291 * sp[18] + -0.1030982623552906 * sp[18] + 0.108253175473054 * sp[17];
    A[203] = 0.1030982623552905 * sp[19] + 0.025774565588822 * sp[18] + 0.08763352300199825 * sp[18] + -0.04639421805987989 * sp[17];
    A[204] = -0.2187044413199079 * sp[19] + 0.2551551815399186 * sp[18] + -0.0364507402199899 * sp[18] + -0.2187044413199265 * sp[17];
    A[205] = -0.4017857142857213 * sp[19] + 0.5580357142857226 * sp[18] + 3.593749999999993 * sp[18] + -0.4017857142857145 * sp[17];
    A[206] = 0.07732369676647624 * sp[19] + 0.06443641397205604 * sp[18] + 0.1675346763273487 * sp[18] + 0.07732369676647269 * sp[17];
    A[207] = -0.7290148043997455 * sp[18] + -0.1458029608799464 * sp[18] + -0.4374088826398529 * sp[17];
    A[208] = 0.8035714285714418 * sp[19] + 0.4017857142857211 * sp[18] + 0.4017857142857211 * sp[18] + 5.357142857142862 * sp[17];
    A[209] = -0.05154913117763512 * sp[18] + -0.2577456558882174 * sp[18] + -0.154647393532928 * sp[17];
    A[210] = 0.06200396825396912 * sp[19] + -0.02108134920634968 * sp[18] + 0.09598214285714141 * sp[18] + 0.05307539682539827 * sp[17];
    A[211] = -0.1240079365079381 * sp[19] + 0.01736111111111151 * sp[18] + -0.2405753968253959 * sp[18] + 0.04365079365079524 * sp[17];
    A[212] = -0.06200396825396948 * sp[19] + 0.04092261904761972 * sp[18] + 0.1460813492063476 * sp[18] + -0.06498015873016062 * sp[17];
    A[213] = 0.0620039682539693 * sp[19] + 0.08308531746031901 * sp[18] + -0.03397817460317251 * sp[18] + 0.04017857142857447 * sp[17];
    A[214] = -0.1240079365079387 * sp[19] + -0.14136904761905 * sp[18] + 0.1165674603174578 * sp[18] + 0.1428571428571432 * sp[17];
    A[215] = -0.06200396825396894 * sp[19] + -0.1029265873015889 * sp[18] + -0.2080853174603164 * sp[18] + -0.3139880952380976 * sp[17];
    A[216] = 0.07440476190476308 * sp[19] + 0.0471230158730166 * sp[18] + 0.01537698412698293 * sp[18] + -0.007936507936507858 * sp[17];
    A[217] = 0.004960317460317706 * sp[18] + -0.1458333333333367 * sp[18] + -0.07043650793651011 * sp[17];
    A[218] = -0.07440476190476356 * sp[19] + -0.02728174603174667 * sp[18] + -0.05902777777777999 * sp[18] + -0.003968253968254367 * sp[17];
    A[219] = -0.3507474113028569 * sp[19] + 0.03507474113028547 * sp[18] + 0.540151013406388 * sp[18] + 0.3226876183986322 * sp[17];
    A[220] = 0.3007032652029474 * sp[19] + 0.2792244605455824 * sp[18] + 0.1761261981902894 * sp[18] + 0.3007032652029413 * sp[17];
    A[221] = -0.6200396825396948 * sp[19] + 0.3596230158730225 * sp[18] + 3.395337301587296 * sp[18] + -0.6200396825397009 * sp[17];
    A[222] = 0.7014948226057132 * sp[19] + 0.3507474113028555 * sp[18] + 0.350747411302855 * sp[18] + 0.2805979290422588 * sp[17];
    A[223] = -0.2577456558882174 * sp[18] + -0.05154913117763512 * sp[18] + -0.154647393532928 * sp[17];
    A[224] = 1.240079365079385 * sp[19] + 0.6200396825396906 * sp[18] + 0.6200396825396906 * sp[18] + 5.615079365079408 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
